/*
 * user32_ia32_syscall_prototypes.h
 *
 * prototypes of IA-32 syscalls.
 *
 */
 /*
 *
 *
 */
 /*
 * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of GNU Lesser General Public
 * License as published by the Free Software Foundation
 * version 2.1 of the License.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Lesser General Public License for more details.
 *
 * You should have recieved a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 * or view it at http://www.gnu.org/licenses/lgpl.html
 *
 * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
*/
//

#ifndef _USER32_IA32_SYSCALL_PROTOTYPES_H
#define _USER32_IA32_SYSCALL_PROTOTYPES_H

#include "ia32ss_common.h"
#include "ia32_networking.h"

long HIDDEN sys32_alarm (unsigned int seconds);
long HIDDEN sys32_brk (unsigned int req_brk);
long HIDDEN sys32_execve (__u32 filename, __u32 argv, __u32 envp);
long HIDDEN sys32_fcntl (int fd, int cmd, __u32 arg);
long HIDDEN sys32_fcntl64 (int fd, int cmd, __u32 arg);
long HIDDEN sys32_fstat64 (int fd, __u32 statbuf);
long HIDDEN sys32_fstatfs (int fd, __u32 buf);
long HIDDEN sys32_ftruncate64 (int fd, __u32 low, __u32 high);
long HIDDEN sys32_getdents (int fd, __u32 dirent, unsigned int count);
long HIDDEN sys32_getgroups16 (int gidsetsize, __u32 grouplist);
long HIDDEN sys32_getitimer (int which, __u32 it);
long HIDDEN sys32_getresgid16 (__u32 rgid, __u32 egid, __u32 sgid);
long HIDDEN sys32_getresuid16 (__u32 ruid, __u32 euid, __u32 suid);
long HIDDEN sys32_getrlimit (unsigned int resource, __u32 rlim);
long HIDDEN sys32_getrusage (int who, __u32 ru);
long HIDDEN sys32_gettimeofday (__u32 tv, __u32 tz);
long HIDDEN sys32_ioctl (int fd, unsigned int cmd, unsigned long arg);
long HIDDEN sys32_ioperm (unsigned int from, unsigned int num, int on);
long HIDDEN sys32_iopl (int level);
long HIDDEN sys32_ipc (__u32 call, int first, int second, int third, __u32 ptr, __u32 fifth);
long HIDDEN sys32_lseek (int fd, int offset, int whence);
long HIDDEN sys32_llseek(int fd, __u32 offset_high, __u32 offset_low, __u32 result, __u32 origin);
long HIDDEN sys32_lstat64 (__u32 filename, __u32 statbuf);
long HIDDEN sys32_mmap (void *arg);
long HIDDEN sys32_mremap (unsigned addr, unsigned old_len, unsigned new_len, unsigned flags, unsigned new_addr);
long HIDDEN sys32_mmap2 (unsigned int addr, unsigned int len, unsigned int prot, unsigned int flags, unsigned int fd, unsigned int pgoff);
long HIDDEN sys32_mprotect (unsigned int start, unsigned int len, int prot);
long HIDDEN sys32_msync (unsigned int start, unsigned int len, int flags);
long HIDDEN sys32_munmap (__u32 start, __u32 len);
long HIDDEN sys32_mlock (unsigned int addr, unsigned int len);
long HIDDEN sys32_munlock (unsigned int addr, unsigned int len);
long HIDDEN sys32_nanosleep (__u32 rqtp, __u32 rmtp);
long HIDDEN sys32_newfstat (int fd, __u32 statbuf);
long HIDDEN sys32_newlstat (__u32 filename, __u32 statbuf);
long HIDDEN sys32_newstat (__u32 filename, __u32 statbuf);
long HIDDEN sys32_newuname (__u32 name);
long HIDDEN sys32_ni_syscall (void);
long HIDDEN sys32_old_getrlimit (unsigned int resource, __u32 rlim);
long HIDDEN sys32_old_select (__u32 arg);
long HIDDEN sys32_pause (void);
long HIDDEN sys32_personality (void);
long HIDDEN sys32_pipe (int fd);
long HIDDEN sys32_pread (int fd, __u32 buf, __u32 count, __u32 low, __u32 high);
long HIDDEN sys32_ptrace (void);
long HIDDEN sys32_pwrite (int fd, __u32 buf, __u32 count, __u32 low, __u32 high);
long HIDDEN sys32_readdir (int fd, __u32 dirent, unsigned int count);
long HIDDEN sys32_readv (int fd, __u32 vector, __u32 count);
long HIDDEN sys32_rt_sigaction (void);
long HIDDEN sys32_rt_sigreturn (void);
long HIDDEN sys32_rt_sigqueueinfo (int pid, int sig, __u32 info);
long HIDDEN sys32_rt_sigtimedwait (const __u32 set, __u32 info, const __u32 timeout, __u32 ss_size);
long HIDDEN sys32_sched_rr_get_interval (int pid, __u32 interval);
long HIDDEN sys32_select (int n, __u32 readfds, __u32 writefds, __u32 exceptfds, __u32 timeout);
long HIDDEN sys32_sendfile (int out_fd, int in_fd, __u32 offset, unsigned int count);
long HIDDEN sys32_setgroups16 (int gidsetsize, __u32 grouplist);
long HIDDEN sys32_setitimer (int which, __u32 in, __u32 out);
long HIDDEN sys32_setrlimit (unsigned int resource, __u32 rlim);
long HIDDEN sys32_settimeofday (__u32 tv, __u32 tz);
long HIDDEN sys32_sigaction (void);
long HIDDEN sys32_sigaltstack (void);
long HIDDEN sys32_signal (void);
long HIDDEN sys32_sigpending (void);
long HIDDEN sys32_rt_sigpending (void);
long HIDDEN sys32_sigprocmask (void);
long HIDDEN sys32_sigreturn (void);
long HIDDEN sys32_socketcall (int call, __u32 args);
long HIDDEN sys32_stat64 (__u32 path, __u32 buf);
long HIDDEN sys32_statfs (__u32 path, __u32 buf);
long HIDDEN sys32_sysctl (__u32 args);
long HIDDEN sys32_sysinfo (__u32 info);
long HIDDEN sys32_time (__u32 tloc);
long HIDDEN sys32_times (__u32 tbuf);
long HIDDEN sys32_truncate64 (__u32 path, __u32 low, __u32 high);
long HIDDEN sys32_utime (__u32 filename, __u32 times32);
long HIDDEN sys32_wait4 (int pid, int *stat_addr, int options, __u32 ru);
long HIDDEN sys32_waitpid (int pid, int *stat_addr, int options);
long HIDDEN sys32_writev (int fd, __u32 vector, __u32 count);
long HIDDEN sys32_nice(int increment);
long HIDDEN sys32_getpgrp(void);
long HIDDEN sys32_clone (void);
long HIDDEN sys32_sendfile64 (int out_fd, int in_fd, __u32 offset, __u32 count);
long HIDDEN sys32_futex (__u32 uaddr, int op, int val, __u32 utime, __u32 uaddr2);
long HIDDEN sys32_io_setup (__u32 nr_events, __u32 ctx32p);
long HIDDEN sys32_io_destroy (__u32 ctx32_id);
long HIDDEN sys32_io_getevents (__u32 ctx32_id, int min_nr, int nr, __u32 events, __u32 timeout); 
long HIDDEN sys32_io_submit (__u32 ctx32_id, int nr, __u32 iocbpp);
long HIDDEN sys32_io_cancel (__u32 ctx32_id, __u32 iocb, __u32 result);
long HIDDEN sys32_adjtimex(__u32 utp);
long HIDDEN sys32_stime(__u32 t);
long HIDDEN sys32_epoll_ctl(int epfd, int op, int fd, __u32 event);
long HIDDEN sys32_epoll_wait(int epfd, __u32 events, int maxevents, int timeout);
long HIDDEN sys32_rt_sigprocmask(void);
long HIDDEN sys32_timer_create(__s32 clockid, __u32 evp, __u32 timerid);
long HIDDEN sys32_timer_settime(__s32 timerid, __s32 flags, __u32 value, __u32 ovalue);
long HIDDEN sys32_timer_gettime(__s32 timerid, __u32 value);
long HIDDEN sys32_clock_settime(__s32 clk_id, __u32 p);
long HIDDEN sys32_clock_gettime(__s32 clk_id, __u32 p);
long HIDDEN sys32_clock_getres(__s32 clk_id, __u32 p);
long HIDDEN sys32_clock_nanosleep(__s32 clk_id, __s32 flags, __u32 qp, __u32 mp);
long HIDDEN sys32_utimes(__u32 filename, __u32 tvp);
long HIDDEN sys32_fstatfs64(__u32 fd, __u32 sz, __u32 buf);

/* in sys.c */
long HIDDEN sys32_oldumount (__u32 name);
long HIDDEN sys_nice (int increment);
long HIDDEN sys32_sigsuspend (void);
long HIDDEN sys32_getpriority (int which, int who);
long HIDDEN sys32_ni_syscall ();

#endif // _USER32_IA32_SYSCALL_PROTOTYPES_H
