/*
 * user32_ni.c
 *
 * contains wrappers for syscalls that are not implemented
 * used only by the external wrapper
 *
 */
 /*
 *
 * Copyright (C) 2005       Yoav Zach <yoav.zach@intel.com>
 * Copyright (C) 2005       Eric Lin <eric.lin@intel.com>
 * Copyright (C) 2005       Bruce Chen <bruce.chen@intel.com>
 * Copyright (C) 2005       Dror Shenkar <dror.shenkar@intel.com>
 *
 */
 /*
 * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of GNU Lesser General Public
 * License as published by the Free Software Foundation
 * version 2.1 of the License.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Lesser General Public License for more details.
 *
 * You should have recieved a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 * or view it at http://www.gnu.org/licenses/lgpl.html
 *
 * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
*/

#include "user32.h"


long HIDDEN sys32_ni_syscall ()
{
	return -ENOSYS;
}
long HIDDEN sys32_ptrace ()
{
	return -ENOSYS;
}
long HIDDEN sys32_rt_sigaction ()
{
	return -ENOSYS;
}
long HIDDEN sys32_rt_sigreturn ()
{
	return -ENOSYS;
}
long HIDDEN sys32_sigaction ()
{
	return -ENOSYS;
}
long HIDDEN sys32_sigaltstack ()
{
	return -ENOSYS;
}
long HIDDEN sys32_signal ()
{
	return -ENOSYS;
}
long HIDDEN sys32_sigreturn ()
{
	return -ENOSYS;
}
long HIDDEN sys32_sigsuspend()
{
	return -ENOSYS;
}
long HIDDEN sys32_clone ()
{
	return -ENOSYS;
}
long HIDDEN sys32_personality ()
{
	return -ENOSYS;
}
long HIDDEN sys32_sigprocmask ()
{
	return -ENOSYS;
}

long HIDDEN sys32_rt_sigprocmask ()
{
	return -ENOSYS;
}

long HIDDEN sys32_sigpending ()
{
	return -ENOSYS;
}

long HIDDEN sys32_rt_sigpending ()
{
	return -ENOSYS;
}


