/* 
 * user32_pathwalk.h
 * prototypes of pathwalk syscall wrappers
 */
 /*
 *
 * Copyright (C) 2005       Yoav Zach <yoav.zach@intel.com>
 * Copyright (C) 2005       Eric Lin <eric.lin@intel.com>
 * Copyright (C) 2005       Bruce Chen <bruce.chen@intel.com>
 * Copyright (C) 2005       Dror Shenkar <dror.shenkar@intel.com>
 *
 */
 /*
 * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of GNU Lesser General Public
 * License as published by the Free Software Foundation
 * version 2.1 of the License.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Lesser General Public License for more details.
 *
 * You should have recieved a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 * or view it at http://www.gnu.org/licenses/lgpl.html
 *
 * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
*/

#ifndef _USER32_PATHWALK_H
#define _USER32_PATHWALK_H
extern long pws_unlink(char * pathname);
extern long pws_chdir(char * filename);
extern long pws_rmdir(char * pathname);
extern long pws_acct(char * filename);
extern long pws_chroot(char * filename);
extern long pws_swapoff(char *specialfile);

extern long pws_creat(char * pathname, int mode);
extern long pws_chmod(char * filename, mode_t mode);
extern long pws_umount(char * name, int flags);
extern long pws_utimes(char * filename, void * utp);
extern long pws_access(char * filename, int mode);
extern long pws_mkdir(char * pathname, int mode);
extern long pws_stat(char * filename, void * statbuf);
extern long pws_lstat(char * filename, void * statbuf);
extern long pws_truncate(char * path, unsigned long length);
extern long pws_statfs(char * path, void * buf);
extern long pws_lremovexattr(char *path, char *name);
extern long pws_removexattr(char *path, char *name);
extern long pws_swapon(char *specialfile, int swap_flags);

extern long pws_open(char * filename, int flags, int mode);
extern long pws_mknod(char * filename, int mode, dev_t dev);
extern long pws_chown(char * filename, uid_t user, gid_t group);
extern long pws_lchown(char * filename, uid_t user, gid_t group);
extern long pws_readlink(char * path, char * buf, int bufsiz);
extern long pws_listxattr(char *path, char *list, size_t size);
extern long pws_llistxattr(char *path, char *list, size_t size);
extern long pws_execve(char *filename, char ** argv, char ** envp);

extern long pws_getxattr(char *path, char *name, void *value, size_t size);
extern long pws_lgetxattr(char *path, char *name, void *value, size_t size);

extern long pws_lsetxattr(char *path, char *name, void *value, size_t size, int flags);
extern long pws_setxattr(char *path, char *name, void *value, size_t size, int flags);

extern long pws_link(char * oldname, char * newname);
extern long pws_pivot_root(char *new_root, char *put_old);
extern long pws_rename(char * oldname, char * newname);
extern long pws_symlink(char * oldname, char * newname);
extern long pws_mount(char * dev_name, char * dir_name, char * type, unsigned long flags, void * data);

#endif // _USER32_PATHWALK_H
