/* 
 * btlib_asm.S
 *
 *
 *
 */
 /*
 *
 * Copyright (C) 2005       Yoav Zach <yoav.zach@intel.com>
 * Copyright (C) 2005       Eric Lin <eric.lin@intel.com>
 * Copyright (C) 2005       Bruce Chen <bruce.chen@intel.com>
 * Copyright (C) 2005       Dror Shenkar <dror.shenkar@intel.com>
 *
 */
 /*
 * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of GNU Lesser General Public
 * License as published by the Free Software Foundation
 * version 2.1 of the License.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Lesser General Public License for more details.
 *
 * You should have recieved a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 * or view it at http://www.gnu.org/licenses/lgpl.html
 *
 * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
*/



#include <ia32x_utils.h>
#include "btlib_offsets.h"

#define FUNC_ENTRY(a)	\
.psr abi64;		\
.psr lsb;		\
.lsb;			\
.text;			\
.global a ; 		\
.proc a ; 		

// __btlib_clone(int (*fn) (void *arg), void *child_stack_base,
// 	         unsigned long child_stack_size, unsigned long flags, void *arg,
//	         pid_t *parent_tid, void *tls, pid_t *child_tid)

FUNC_ENTRY(__btlib_clone)
__btlib_clone:
.unwentry
	alloc loc0=ar.pfs, 8, 3, 6, 0  
	;;
	flushrs

	mov loc1=in0	/* save fn */
	mov loc2=in4	/* save arg */

	mov out0=in3	/* clone flag */
	mov out1=in1	/* stack address */
	mov out2=in2	/* stack size */
	mov out3=in5	/* parent TID pointer, for CLONE_PARENT(CHILD)_SETTID */
	mov out4=in7	/* child TID pointer, for CLONE_CHILD_CLEARTID */
	mov out5=in6	/* TLS pointer, for CLONE_SETTLS */
	mov r15=__NR_clone2
	break.i __BREAK_SYSCALL
	cmp.eq p6,p7=-1, r10
	;;
(p6)	sub r8=r0, r8
(p7)	cmp.eq p0,p6=0,r8

	mov out0=loc2 
	;;

(p6)	mov ar.pfs = loc0
(p6)	br.ret.spnt.few b0

	add sp=-16, sp
	ld8 loc2=[loc1], 8 
	;;
	ld8 r1=[loc1]
	mov b6=loc2 
	;;
	br.call.sptk.few b0=b6 
	;;

	mov r15=__NR_exit
	break.i __BREAK_SYSCALL
.endp __btlib_clone


//
// void __flush_instruction_cache(void * address, unsigned size)
//
#define CACHE_LINE_SIZE 32
FUNC_ENTRY(__flush_instruction_cache)
__flush_instruction_cache:
.unwentry
    alloc   loc0 = ar.pfs, 2, 1, 0, 0
    brp.sptk looplab, loopbranch


looplab:
    fc      in0               // flush stale data from instruction/data cache
    add     in0 =  CACHE_LINE_SIZE, in0
    add     in1 = -CACHE_LINE_SIZE, in1
	;;
    cmp4.lt p9, p0 = 0, in1 
[loopbranch:] (p9)br.cond.sptk looplab
	

    //Serialize
    sync.i
	;;
    srlz.i

    br.ret.sptk b0

.endp __flush_instruction_cache


//
// __btlib_signal_handler (int signo, siginfo_t * siginfo, struct sigcontext * sc64)
//
// copy all the registers that are part of the context and are 
// not copied by the kernel -
//	sc_ar_bsp
//	sc_ar_rnat
//	sc_ar_lc
//	sc_br[1-5]
//	sc_gr[4-7]
//	sc_fr[2-7]
//	sc_fr[16-31]
//
FUNC_ENTRY(__btlib_signal_handler)
__btlib_signal_handler:
.unwentry


	/* allocate a new frame */

	alloc	loc0=ar.pfs,3,7,3,0
	cmp.eq	p14,p15=PTEMU_SIG0, in0 /* is ptemu-signal ? */
	mov	loc5=b0
	;;

	flushrs		/* make bspstore equal to bsp */ 
	mov loc1=in2	/* loc1 holds the base addr of the context struct */
	tnat.nz p6,p7=r4
	;;

	/* get the backing-store related regs */
	mov	loc2=ar.bsp	/* loc2 holds bsp */
	adds 	loc4=STRCUT_SIGCONTEXT_OFFSETOF_AR_BSP, loc1
	adds 	loc6=STRCUT_SIGCONTEXT_OFFSETOF_NAT, loc1
	;;

	st8	[loc4]=loc2	/* store bsp */
	mov	loc3=ar.rsc	/* loc3 holds the orig rsc */
	ld8 	loc6=[loc6]	/* loc6 holds the sc_nat field */
	;;

	and	loc4=-4, loc3
	tnat.nz p8,p9=r5
	;;

	mov	ar.rsc=loc4
	tnat.nz p10,p11=r6
	;;

	mov	loc4=ar.rnat		/* loc4 holds rnat */
	tnat.nz p12,p13=r7
	adds 	loc2=STRCUT_SIGCONTEXT_OFFSETOF_AR_RNAT, loc1
	;;

	mov	ar.rsc=loc3		/* restore rsc */
	st8	[loc2]=loc4		/* store rnat */
	;;
	
	adds 	loc3=STRCUT_SIGCONTEXT_OFFSETOF_AR_LC, loc1
	mov 	loc4=ar.lc
	;;
	
	st8 	[loc3]=loc4		/* store ar.lc */
	adds 	loc2=STRCUT_SIGCONTEXT_OFFSETOF_BR_1, loc1
	adds 	loc3=STRCUT_SIGCONTEXT_OFFSETOF_GR_4, loc1
	mov 	loc4=b1
	;;
	
	st8 	[loc2]=loc4, 8		/* store b1 */
(p6)	st8	[loc3]=r4, 8		/* store r4 */
(p7)	or	loc6=0x10, loc6		/* set the nat bit for r4 */
	mov 	loc4=b2
	;;

	st8 	[loc2]=loc4, 8		/* store b2 */
(p8)	st8	[loc3]=r5, 8		/* store r5 */
(p7)	or	loc6=0x20, loc6		/* set the nat bit for r5 */
	mov 	loc4=b3
	;;

	st8 	[loc2]=loc4, 8		/* store b3 */
(p10)	st8	[loc3]=r6, 8		/* store r6 */
(p11)	or	loc6=0x40, loc6		/* set the nat bit for r6 */
	mov 	loc4=b4
	;;

	st8 	[loc2]=loc4, 8		/* store b4 */
(p12)	st8	[loc3]=r7, 8		/* store r7 */
	mov 	loc4=b5
	;;

	st8 	[loc2]=loc4, 8		/* store b5 */
	;;

	adds 	loc2=STRCUT_SIGCONTEXT_OFFSETOF_FR_2, loc1
	adds 	loc3=STRCUT_SIGCONTEXT_OFFSETOF_FR_3, loc1
	;;
	
	mov	loc4=0x80
	stf.spill [loc2]=f2, 32
	stf.spill [loc3]=f3, 32
	;;

(p13)	or	loc6=loc4, loc6		/* set the nat bit for r7 */
	stf.spill [loc2]=f4
	stf.spill [loc3]=f5
	;;

	adds loc4=STRCUT_SIGCONTEXT_OFFSETOF_NAT, loc1
	adds loc2=STRCUT_SIGCONTEXT_OFFSETOF_FR_16, loc1
	adds loc3=STRCUT_SIGCONTEXT_OFFSETOF_FR_17, loc1
	;;

	st8 [loc4]=loc6			/* store the nat bits for r4-r7 */
	stf.spill [loc2]=f16, 32
	stf.spill [loc3]=f17, 32
	;;

	stf.spill [loc2]=f18, 32
	stf.spill [loc3]=f19, 32
	;;

	stf.spill [loc2]=f20, 32
	stf.spill [loc3]=f21, 32
	;;

	stf.spill [loc2]=f22, 32
	stf.spill [loc3]=f23, 32
	;;

	stf.spill [loc2]=f24, 32
	stf.spill [loc3]=f25, 32
	;;

	stf.spill [loc2]=f26, 32
	stf.spill [loc3]=f27, 32
	;;

	stf.spill [loc2]=f28, 32
	stf.spill [loc3]=f29, 32
	;;

	stf.spill [loc2]=f30
	stf.spill [loc3]=f31
	;;

	/* move the input regs to output regs */
	mov out0=in0
	mov out1=in1
	mov out2=in2

	/* call the signal handler */
.global btlib_signal_handler
(p14)	br.call.sptk.many b0=btlib_ptemu0_handler
(p15)	br.call.sptk.many b0=btlib_signal_handler

	/* return to the system */
	mov b0=loc5
	mov ar.pfs=loc0
	br.ret.sptk.many b0
.endp __btlib_signal_handler


// __btlib_exit (int errno, void *stack, unsigned long len);


FUNC_ENTRY(__btlib_exit)
__btlib_exit:
.unwentry
	alloc loc0 = ar.pfs, 3, 7, 2, 0

        /* call munamp to free stack of current thread */
	mov   out0 = in1
	mov   out1 = in2

	/* enter RBS lazy mode here? */

.global sys_munmap
	;;
	br.call.sptk.many  b0 = sys_munmap

	/* don't access user stack from now */
.global sys_exit
	mov   out0 = in0
	br.call.sptk.many  b0 = sys_exit
	;;
        br.ret.sptk.many b0
.endp __btlib_exit



