/* 
 * btlib_asm.h
 *
 * forward declerations for btlib_asm.S
 *
 */
 /*
 *
 * Copyright (C) 2005       Yoav Zach <yoav.zach@intel.com>
 * Copyright (C) 2005       Eric Lin <eric.lin@intel.com>
 * Copyright (C) 2005       Bruce Chen <bruce.chen@intel.com>
 * Copyright (C) 2005       Dror Shenkar <dror.shenkar@intel.com>
 *
 */
 /*
 * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of GNU Lesser General Public
 * License as published by the Free Software Foundation
 * version 2.1 of the License.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Lesser General Public License for more details.
 *
 * You should have recieved a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 * or view it at http://www.gnu.org/licenses/lgpl.html
 *
 * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
*/

#ifndef BTLIB_ASM_H
#define BTLIB_ASM_H

struct sigcontext;
struct siginfo;
extern void __btlib_signal_handler (int signo, struct siginfo *siginfo,
				    struct sigcontext *sc64);
extern void __flush_instruction_cache (void *address, unsigned size);
extern int __btlib_clone (int (*fn) (void *arg), void *child_stack,
			  unsigned long stack_size, unsigned long flags,
			  void *arg, void *parent_tid, void *tls,
			  void *child_tid);

#define __btlib_read_timestamp_counter() \
({	\
	unsigned long _ts;    \
	__asm__ __volatile__ ("mov %0=ar.itc;;\n":"=r"(_ts));    \
	_ts;    \
})


#endif				/* BTLIB_ASM_H */
