/*  
 * btlib_ptemu.h
 *  
 * this file contains definitions for btlib_ptemu.h. 
 * 
*/
 /*
 *
 * Copyright (C) 2005       Yoav Zach <yoav.zach@intel.com>
 * Copyright (C) 2005       Eric Lin <eric.lin@intel.com>
 * Copyright (C) 2005       Bruce Chen <bruce.chen@intel.com>
 * Copyright (C) 2005       Dror Shenkar <dror.shenkar@intel.com>
 *
 */
 /*
 * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of GNU Lesser General Public
 * License as published by the Free Software Foundation
 * version 2.1 of the License.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Lesser General Public License for more details.
 *
 * You should have recieved a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 * or view it at http://www.gnu.org/licenses/lgpl.html
 *
 * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
*/

#ifndef _BTLIB_PTEMU_H
#define _BTLIB_PTEMU_H

#define IS_PTRACED_NO 0ul 
#define IS_PTRACED_YES_NOT_READY 1ul 
#define IS_PTRACED_YES  2ul

typedef struct _debugee_t {
	struct _debugee_t *next;	/* next elem in the list */
	unsigned long flags;	/* info about debugee */
	unsigned long blst;	/* blst of the debugee */
	int pid;		/* pid of debugee */
	int stop_signo;		/* the signal that made the debugee stop
				 * assigned at btlib_ptemu_wait. need to
				 * be cleared upon continuing the debugee - 
				 * ptemu_cont, ptemu_syscall, ptemu_singlestep
				 */
} debugee_t;

inline void *get_debugee_glst_address(debugee_t *debugee);
inline void *get_debugee_blst_address(debugee_t *debugee);

#endif				// _BTLIB_PTEMU_H
