/* 
 * btlib_stats.h
 * interface for collecting and printing statistics
 * 
 *
 */
 /*
 *
 * Copyright (C) 2005       Yoav Zach <yoav.zach@intel.com>
 * Copyright (C) 2005       Eric Lin <eric.lin@intel.com>
 * Copyright (C) 2005       Bruce Chen <bruce.chen@intel.com>
 * Copyright (C) 2005       Dror Shenkar <dror.shenkar@intel.com>
 *
 */
 /*
 * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of GNU Lesser General Public
 * License as published by the Free Software Foundation
 * version 2.1 of the License.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Lesser General Public License for more details.
 *
 * You should have recieved a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 * or view it at http://www.gnu.org/licenses/lgpl.html
 *
 * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
*/

#ifndef _BTLIB_STATS_H
#define _BTLIB_STATS_H

#if STAT
/* entries in the stats-array */
enum btl_stat_ind {
	BTL_STAT_MAX_PENDING,
	BTL_STAT_SIG_PASS,
	BTL_STAT_STACK_FREE,
	BTL_STAT_STACK_REUSE,
	BTL_STAT_MAX_FREE_STACK_LIST_SIZE,
	BTL_STAT_SIG,
	BTL_STAT_SYNC_SIG,
	BTL_STAT_ASYNC_SIG,
	BTL_STAT_SYSCALL,
	BTL_STAT_LSYSCALL,
	BTL_STAT_BTGJUMP,
	BTL_STAT_PROC_FDS,
	/* last one */
	BTL_MAX_STAT_IND
};

enum btl_stat_type {
	MAX_VAL,
	COUNT
};

extern char btl_stats;
void btlib_update_stat (int ind, int type, unsigned long new_val);
void btlib_print_stats (void);

#endif				// STAT

#endif				// _BTLIB_STATS_H
