/*  
 * btlib_sync.h
 *  
 * 
 * 
*/
 /*
 *
 * Copyright (C) 2005       Yoav Zach <yoav.zach@intel.com>
 * Copyright (C) 2005       Eric Lin <eric.lin@intel.com>
 * Copyright (C) 2005       Bruce Chen <bruce.chen@intel.com>
 * Copyright (C) 2005       Dror Shenkar <dror.shenkar@intel.com>
 *
 */
 /*
 * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of GNU Lesser General Public
 * License as published by the Free Software Foundation
 * version 2.1 of the License.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Lesser General Public License for more details.
 *
 * You should have recieved a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 * or view it at http://www.gnu.org/licenses/lgpl.html
 *
 * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
*/

#ifndef _BTLIB_SYNC_H
#define _BTLIB_SYNC_H

struct critical_section_t;

/* this enum sets the priority of the sync objects inside btlib */
enum btl_lock_ind {
	/* low priority */
    	BTL_LOCK_IND_SUSPENSION = 1,
	BTL_LOCK_IND_THREAD_SCALABILITY,
	BTL_LOCK_IND_SHARED_QUE,
	BTL_LOCK_IND_THREAD,
	BTL_LOCK_IND_FREE_STACK,
	BTL_LOCK_IND_SIGHAND,
	BTL_LOCK_IND_CS,
	BTL_LOCK_IND_LDT,
	BTL_LOCK_IND_INTERNAL_MEM,
	/* high priority */
	BTL_MAX_LOCK_IND
};

void btlib_init_sync_module (void);
void btlib_freeze (void);
void btlib_unfreeze (long is_parent);
void btlib_acquire_lock (int);
void btlib_release_lock (int);

#if DEBUG
long btlib_is_inside_lock (btlib_thread_data_t *);
#endif				// DEBUG

#endif				// _BTLIB_SYNC_H
