/*  
 * btload_pub.h
 *  
 * 
 * 
*/
 /*
 *
 * Copyright (C) 2005       Yoav Zach <yoav.zach@intel.com>
 * Copyright (C) 2005       Eric Lin <eric.lin@intel.com>
 * Copyright (C) 2005       Bruce Chen <bruce.chen@intel.com>
 * Copyright (C) 2005       Dror Shenkar <dror.shenkar@intel.com>
 * Copyright (C) 2005       Doron Ziffrony
 *
 */
 /*
 * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of GNU Lesser General Public
 * License as published by the Free Software Foundation
 * version 2.1 of the License.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Lesser General Public License for more details.
 *
 * You should have recieved a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 * or view it at http://www.gnu.org/licenses/lgpl.html
 *
 * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
*/

#ifndef _BTLOAD_PUB_H
#define _BTLOAD_PUB_H

#include "os_dep_linux.h"
#include "new_pe.h"

/* FILE: btload.c */
BT_U64 image_read(int fd, BT_U64 offset, BT_U64 size, void * buffer);
BT_U64 verify_coff_header(coff_header_type * coff_header_ptr);
BT_U64 verify_optional_header(opt_header_type * opt_header_ptr);
BT_U64 load_section_headers(BT_U64 num_of_sections,
                            BT_U64 image_size,
                            BT_U64 image_load_addr,
                            int fd,
                            BT_U64 * alloced_mem_size,
                            psection_header_type * sections_table_ptr);
BT_U64 load_relocations(psection_header_type reloc_sect_header_ptr,
                        int fd,
                        BT_U64 target_address,
                        fixup_block_type ** head_reloc_table_ptr);
BT_U64 load_section(psection_header_type sect_header_ptr,
                    int fd,
                    BT_U64 target_address, long);
BT_U64 load_pe_binary(char * path,
                      void ** p_target_address,
                      void ** api_table_address,
                      BT_U64 * p_load_size,
                      unsigned long rsrc[2]);

#endif /* _BTLOAD_PUB_H */

