/*  
 * os_dep_linux.h
 *  
 * 
 * 
*/
 /*
 *
 * Copyright (C) 2005       Yoav Zach <yoav.zach@intel.com>
 * Copyright (C) 2005       Eric Lin <eric.lin@intel.com>
 * Copyright (C) 2005       Bruce Chen <bruce.chen@intel.com>
 * Copyright (C) 2005       Dror Shenkar <dror.shenkar@intel.com>
 * Copyright (C) 2005       Doron Ziffrony
 *
 */
 /*
 * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of GNU Lesser General Public
 * License as published by the Free Software Foundation
 * version 2.1 of the License.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Lesser General Public License for more details.
 *
 * You should have recieved a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 * or view it at http://www.gnu.org/licenses/lgpl.html
 *
 * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
*/

#ifndef __OS_DEP_LINUX_H__
#define	__OS_DEP_LINUX_H__

/*
 * NOTE:  This include file must be the first in the line of includes!
 */

#include <ia32x_utils.h>

#define FUNC

#define STDERR  stderr

/*
 * Define I/O functions and parameters
 */

#define OS_OPEN(a,b)	     sys_open(a, b, -1)
#define OS_READ		     sys_read
#define OS_WRITE	     sys_write
#define OS_LSEEK	     sys_lseek
#define OS_CLOSE	     sys_close
#define OS_GET_MEMORY    linux_allocate_memory
#define OS_FREE_MEMORY   linux_free_memory
#define OS_GET_PAGE_SIZE linux_get_page_size
#define OS_MAP_FILE      linux_map_file_to_memory
#define OS_CREATE_MAP    linux_create_map_file
#define OS_PAGES_TO_NON_WRITABLE linux_pages_to_non_writable

#define OS_RDONLY O_RDONLY

#define OS_PROT_READ   PROT_READ
#define OS_PROT_WRITE  PROT_WRITE
#define OS_PROT_EXEC   PROT_EXEC


/*
 * Define types
 */

typedef unsigned char		BT_U8;    /* type of 8 bit items */
typedef unsigned short		BT_U16;   /* type of 16 bit items */
typedef unsigned int		BT_U32;   /* type of 32 bit items */
typedef unsigned long		BT_U64;   /* type of 64 bits unsigned items.  Linux specific */
typedef signed char		BT_S8;    /* type of 8 bit items */
typedef signed short		BT_S16;   /* type of 16 bit items */
typedef signed int		BT_S32;   /* type of 32 bit items */
typedef signed long		BT_S64;   /* type of 64 bits signed items.  Linux specific */

typedef BT_U8	bool;     /* Boolean */


// DEBUG macros

#ifdef DEBUG
#ifndef DBPRINT
#define DBPRINT     if(1)fprintf
#endif
#define IFDB(switch)    if(switch)
#else
#ifndef DBPRINT
#define DBPRINT     if(0)fprintf
#endif
#define IFDB(switch)    if(0)
#endif  /* DEBUG */

/* function prototypes */
#define UNUSED __attribute__ ((unused))

#endif

