/*  
 * os_dep_pub.h
 *  
 * 
 * 
*/
 /*
 *
 * Copyright (C) 2005       Yoav Zach <yoav.zach@intel.com>
 * Copyright (C) 2005       Eric Lin <eric.lin@intel.com>
 * Copyright (C) 2005       Bruce Chen <bruce.chen@intel.com>
 * Copyright (C) 2005       Dror Shenkar <dror.shenkar@intel.com>
 * Copyright (C) 2005       Doron Ziffrony
 *
 */
 /*
 * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of GNU Lesser General Public
 * License as published by the Free Software Foundation
 * version 2.1 of the License.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Lesser General Public License for more details.
 *
 * You should have recieved a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 * or view it at http://www.gnu.org/licenses/lgpl.html
 *
 * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
*/

#ifndef _OS_DEP_PUB_H
#define _OS_DEP_PUB_H

BT_U64 linux_get_page_size(void);
BT_U64 linux_allocate_memory(BT_U64 page_address,
                             BT_U64 size,
                             BT_U64 protection,
                             BT_U64 * returned_size,
                             void   ** mem_ptr);
BT_U64 linux_free_memory(BT_U64 page_address, BT_U64 size);
BT_U64 linux_map_file_to_memory(BT_U64 page_address,
                                BT_U64 size, 
                                BT_U64 file_offset,
                                BT_U64 protection,
                                int   shared,
                                int    fd,
                                BT_U64 * returned_size,
                                void   ** mem_ptr);
BT_U64 linux_pages_to_non_writable(BT_U64 page_address, BT_U64 num_pages, int is_executable);
BT_U64 linux_create_map_file(int fd, BT_U64 low_offset, BT_U64 high_offset, int * map_handle);

#endif /* _OS_DEP_PUB_H */
