/*  
 * make_btlib_offsets_h.c
 *  
 * 
 * 
*/
 /*
 *
 * Copyright (C) 2005       Yoav Zach <yoav.zach@intel.com>
 * Copyright (C) 2005       Eric Lin <eric.lin@intel.com>
 * Copyright (C) 2005       Bruce Chen <bruce.chen@intel.com>
 * Copyright (C) 2005       Dror Shenkar <dror.shenkar@intel.com>
 *
 */
 /*
 * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of GNU Lesser General Public
 * License as published by the Free Software Foundation
 * version 2.1 of the License.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Lesser General Public License for more details.
 *
 * You should have recieved a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 * or view it at http://www.gnu.org/licenses/lgpl.html
 *
 * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
*/

#include <ia32x_utils.h>
#include "btlib.h"

#define OFFSETOF(field,struct_type) (unsigned long)&(((struct_type*)0)->field)

int main (int argc UNUSED, char ** argv UNUSED, char ** envp UNUSED)
{

	printf ("#define STRCUT_SIGCONTEXT_OFFSETOF_AR_BSP %ld\n",
		OFFSETOF (sc_ar_bsp, struct sigcontext));
	printf ("#define STRCUT_SIGCONTEXT_OFFSETOF_AR_RNAT %ld\n",
		OFFSETOF (sc_ar_rnat, struct sigcontext));
	printf ("#define STRCUT_SIGCONTEXT_OFFSETOF_NAT %ld\n",
		OFFSETOF (sc_nat, struct sigcontext));
	printf ("#define STRCUT_SIGCONTEXT_OFFSETOF_AR_LC %ld\n",
		OFFSETOF (sc_ar_lc, struct sigcontext));
	printf ("#define STRCUT_SIGCONTEXT_OFFSETOF_BR_1 %ld\n",
		OFFSETOF (sc_br[1], struct sigcontext));
	printf ("#define STRCUT_SIGCONTEXT_OFFSETOF_GR_4 %ld\n",
		OFFSETOF (sc_gr[4], struct sigcontext));
	printf ("#define STRCUT_SIGCONTEXT_OFFSETOF_FR_2 %ld\n",
		OFFSETOF (sc_fr[2], struct sigcontext));
	printf ("#define STRCUT_SIGCONTEXT_OFFSETOF_FR_3 %ld\n",
		OFFSETOF (sc_fr[3], struct sigcontext));
	printf ("#define STRCUT_SIGCONTEXT_OFFSETOF_FR_16 %ld\n",
		OFFSETOF (sc_fr[16], struct sigcontext));
	printf ("#define STRCUT_SIGCONTEXT_OFFSETOF_FR_17 %ld\n",
		OFFSETOF (sc_fr[17], struct sigcontext));

	/* this is not offset, but it is needed in the asm file nevertheless */
	printf ("#define PTEMU_SIG0 %d\n", PTEMU_SIG0);
	return 0;
}
