/*  
 * assert.c
 *  
 * implementation of __assert_fail function
 * 
*/
 /*
 *
 * This file has been derived from GNU libc. Please see COPYING.LIBC
 * for more information
 *
 */
 /*
 * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of GNU Lesser General Public
 * License as published by the Free Software Foundation
 * version 2.1 of the License.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Lesser General Public License for more details.
 *
 * You should have recieved a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 * or view it at http://www.gnu.org/licenses/lgpl.html
 *
 * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
*/

#include "../ia32x_utils.h"

#if DEBUG
/* the standard function does not print the tid */
void __assert_fail (__const char *__assertion, __const char *__file,
						unsigned int __line, __const char *__function)
{
	fprintf (g_log_file, "(%d) Assertion failed:%s:%d:%s:'%s'\n",
			SYSCALL (gettid, ()), __file, __line, __function, __assertion);
	SYSCALL (exit_group, (-1));
	/* in case exit_group is not supported */
	SYSCALL (kill, (SYSCALL (getpid, ()), SIGKILL));
	/* make it noreturn */
	SYSCALL (exit, (-1));
}
#endif
