/* 
 * ia32x_utils_internal.h
 * definitions needed for internal use of the ia32x_utils lib
 */
 /*
 *
 * This file has been derived from GNU libc. Please see COPYING.LIBC
 * for more information
 *
 */
 /*
 * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of GNU Lesser General Public
 * License as published by the Free Software Foundation
 * version 2.1 of the License.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Lesser General Public License for more details.
 *
 * You should have recieved a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 * or view it at http://www.gnu.org/licenses/lgpl.html
 *
 * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
*/
#ifndef _LIBC_SUBST_INTERNAL_H
#define _LIBC_SUBST_INTERNAL_H

#include "mutex_internal.h"

extern int mutex_module_init (void);
extern int malloc_module_init (void);
extern int malloc_lock (void);
extern int malloc_unlock (void);
extern long allocate_initial_tls (void);

/* program headers */
extern void * g_at_phdr;
extern unsigned long g_at_phnum;

#if DEBUG
#define LOG(format,args...) do {				\
	fprintf (g_log_file, "(%d) %s:%s - " format, 		\
		 sys_gettid(), __FILE__, __FUNCTION__, ## args);\
} while (0)
#else
#define LOG(format,args...)
#endif

#endif // _LIBC_SUBST_INTERNAL_H
