/* 
 * kernel_subst64.h
 * macro / structure definitions on 64-bits linux
 */
 /*
 *
 * This file has been derived from GNU libc. Please see COPYING.LIBC
 * for more information
 *
 */
 /*
 * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of GNU Lesser General Public
 * License as published by the Free Software Foundation
 * version 2.1 of the License.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Lesser General Public License for more details.
 *
 * You should have recieved a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 * or view it at http://www.gnu.org/licenses/lgpl.html
 *
 * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
*/

#ifndef _KERNEL_SUBST64_H
#define _KERNEL_SUBST64_H

#ifndef _LIBC_SUBST_H
# error "Never include kernel_subst64.h directly; use <ia32x_utils.h> instead."
#endif

#include <sysdep-generic.h>
#include <sysdep.h>

/* from  asm/break.h */
#define __IA64_BREAK_SYSCALL		0x100000

/* from  asm/unistd.h */
#define __NR_ni_syscall			1024
#define __NR_exit			1025
#define __NR_read			1026
#define __NR_write			1027
#define __NR_open			1028
#define __NR_close			1029
#define __NR_creat			1030
#define __NR_link			1031
#define __NR_unlink			1032
#define __NR_execve			1033
#define __NR_chdir			1034
#define __NR_fchdir			1035
#define __NR_utimes			1036
#define __NR_mknod			1037
#define __NR_chmod			1038
#define __NR_chown			1039
#define __NR_lseek			1040
#define __NR_getpid			1041
#define __NR_getppid			1042
#define __NR_mount			1043
#define __NR_umount			1044
#define __NR_setuid			1045
#define __NR_getuid			1046
#define __NR_geteuid			1047
#define __NR_ptrace			1048
#define __NR_access			1049
#define __NR_sync			1050
#define __NR_fsync			1051
#define __NR_fdatasync			1052
#define __NR_kill			1053
#define __NR_rename			1054
#define __NR_mkdir			1055
#define __NR_rmdir			1056
#define __NR_dup			1057
#define __NR_pipe			1058
#define __NR_times			1059
#define __NR_brk			1060
#define __NR_setgid			1061
#define __NR_getgid			1062
#define __NR_getegid			1063
#define __NR_acct			1064
#define __NR_ioctl			1065
#define __NR_fcntl			1066
#define __NR_umask			1067
#define __NR_chroot			1068
#define __NR_ustat			1069
#define __NR_dup2			1070
#define __NR_setreuid			1071
#define __NR_setregid			1072
#define __NR_getresuid			1073
#define __NR_setresuid			1074
#define __NR_getresgid			1075
#define __NR_setresgid			1076
#define __NR_getgroups			1077
#define __NR_setgroups			1078
#define __NR_getpgid			1079
#define __NR_setpgid			1080
#define __NR_setsid			1081
#define __NR_getsid			1082
#define __NR_sethostname		1083
#define __NR_setrlimit			1084
#define __NR_getrlimit			1085
#define __NR_getrusage			1086
#define __NR_gettimeofday		1087
#define __NR_settimeofday		1088
#define __NR_select			1089
#define __NR_poll			1090
#define __NR_symlink			1091
#define __NR_readlink			1092
#define __NR_uselib			1093
#define __NR_swapon			1094
#define __NR_swapoff			1095
#define __NR_reboot			1096
#define __NR_truncate			1097
#define __NR_ftruncate			1098
#define __NR_fchmod			1099
#define __NR_fchown			1100
#define __NR_getpriority		1101
#define __NR_setpriority		1102
#define __NR_statfs			1103
#define __NR_fstatfs			1104
#define __NR_gettid			1105
#define __NR_semget			1106
#define __NR_semop			1107
#define __NR_semctl			1108
#define __NR_msgget			1109
#define __NR_msgsnd			1110
#define __NR_msgrcv			1111
#define __NR_msgctl			1112
#define __NR_shmget			1113
#define __NR_shmat			1114
#define __NR_shmdt			1115
#define __NR_shmctl			1116
#define __NR_syslog			1117
#define __NR_setitimer			1118
#define __NR_getitimer			1119
#define __NR_old_stat			1120
#define __NR_old_lstat			1121
#define __NR_old_fstat			1122
#define __NR_vhangup			1123
#define __NR_lchown			1124
#define __NR_vm86			1125
#define __NR_wait4			1126
#define __NR_sysinfo			1127
#define __NR_clone			1128
#define __NR_setdomainname		1129
#define __NR_uname			1130
#define __NR_adjtimex			1131
#define __NR_create_module		1132
#define __NR_init_module		1133
#define __NR_delete_module		1134
#define __NR_get_kernel_syms		1135
#define __NR_query_module		1136
#define __NR_quotactl			1137
#define __NR_bdflush			1138
#define __NR_sysfs			1139
#define __NR_personality		1140
#define __NR_afs_syscall		1141
#define __NR_setfsuid			1142
#define __NR_setfsgid			1143
#define __NR_getdents			1144
#define __NR_flock			1145
#define __NR_readv			1146
#define __NR_writev			1147
#define __NR_pread			1148
#define __NR_pwrite			1149
#define __NR__sysctl			1150
#define __NR_mmap			1151
#define __NR_munmap			1152
#define __NR_mlock			1153
#define __NR_mlockall			1154
#define __NR_mprotect			1155
#define __NR_mremap			1156
#define __NR_msync			1157
#define __NR_munlock			1158
#define __NR_munlockall			1159
#define __NR_sched_getparam		1160
#define __NR_sched_setparam		1161
#define __NR_sched_getscheduler		1162
#define __NR_sched_setscheduler		1163
#define __NR_sched_yield		1164
#define __NR_sched_get_priority_max	1165
#define __NR_sched_get_priority_min	1166
#define __NR_sched_rr_get_interval	1167
#define __NR_nanosleep			1168
#define __NR_nfsservctl			1169
#define __NR_prctl			1170
#define __NR_mmap2			1172
#define __NR_pciconfig_read		1173
#define __NR_pciconfig_write		1174
#define __NR_perfmonctl			1175
#define __NR_sigaltstack		1176
#define __NR_rt_sigaction		1177
#define __NR_rt_sigpending		1178
#define __NR_rt_sigprocmask		1179
#define __NR_rt_sigqueueinfo		1180
#define __NR_rt_sigreturn		1181
#define __NR_rt_sigsuspend		1182
#define __NR_rt_sigtimedwait		1183
#define __NR_getcwd			1184
#define __NR_capget			1185
#define __NR_capset			1186
#define __NR_sendfile			1187
#define __NR_getpmsg			1188
#define __NR_putpmsg			1189
#define __NR_socket			1190
#define __NR_bind			1191
#define __NR_connect			1192
#define __NR_listen			1193
#define __NR_accept			1194
#define __NR_getsockname		1195
#define __NR_getpeername		1196
#define __NR_socketpair			1197
#define __NR_send			1198
#define __NR_sendto			1199
#define __NR_recv			1200
#define __NR_recvfrom			1201
#define __NR_shutdown			1202
#define __NR_setsockopt			1203
#define __NR_getsockopt			1204
#define __NR_sendmsg			1205
#define __NR_recvmsg			1206
#define __NR_pivot_root			1207
#define __NR_mincore			1208
#define __NR_madvise			1209
#define __NR_stat			1210
#define __NR_lstat			1211
#define __NR_fstat			1212
#define __NR_clone2			1213
#define __NR_getdents64			1214
#define __NR_getunwind			1215
#define __NR_readahead			1216
#define __NR_setxattr			1217
#define __NR_lsetxattr			1218
#define __NR_fsetxattr			1219
#define __NR_getxattr			1220
#define __NR_lgetxattr			1221
#define __NR_fgetxattr			1222
#define __NR_listxattr			1223
#define __NR_llistxattr			1224
#define __NR_flistxattr			1225
#define __NR_removexattr		1226
#define __NR_lremovexattr		1227
#define __NR_fremovexattr		1228
#define __NR_tkill			1229
#define __NR_futex			1230
#define __NR_sched_setaffinity		1231
#define __NR_sched_getaffinity		1232
#define __NR_set_tid_address		1233
#define __NR_fadvise64			1234
#define __NR_tgkill			1235
#define __NR_exit_group			1236
#define __NR_lookup_dcookie		1237
#define __NR_io_setup			1238
#define __NR_io_destroy			1239
#define __NR_io_getevents		1240
#define __NR_io_submit			1241
#define __NR_io_cancel			1242
#define __NR_epoll_create		1243
#define __NR_epoll_ctl			1244
#define __NR_epoll_wait			1245
#define __NR_restart_syscall		1246
#define __NR_semtimedop			1247
#define __NR_timer_create               1248
#define __NR_timer_settime              1249
#define __NR_timer_gettime              1250
#define __NR_timer_getoverrun           1251
#define __NR_timer_delete               1252
#define __NR_clock_settime              1253
#define __NR_clock_gettime              1254
#define __NR_clock_getres               1255
#define __NR_clock_nanosleep            1256
#define __NR_fstatfs64                  1257

#define __BREAK_SYSCALL                 __IA64_BREAK_SYSCALL
/* from  bits/syscall.h */
#define SYS__sysctl __NR__sysctl
#define SYS_accept __NR_accept
#define SYS_access __NR_access
#define SYS_acct __NR_acct
#define SYS_adjtimex __NR_adjtimex
#define SYS_afs_syscall __NR_afs_syscall
#define SYS_bdflush __NR_bdflush
#define SYS_bind __NR_bind
#define SYS_brk __NR_brk
#define SYS_capget __NR_capget
#define SYS_capset __NR_capset
#define SYS_chdir __NR_chdir
#define SYS_chmod __NR_chmod
#define SYS_chown __NR_chown
#define SYS_chroot __NR_chroot
#define SYS_clone __NR_clone
#define SYS_clone2 __NR_clone2
#define SYS_close __NR_close
#define SYS_connect __NR_connect
#define SYS_creat __NR_creat
#define SYS_create_module __NR_create_module
#define SYS_delete_module __NR_delete_module
#define SYS_dup __NR_dup
#define SYS_dup2 __NR_dup2
#define SYS_epoll_create __NR_epoll_create
#define SYS_epoll_ctl __NR_epoll_ctl
#define SYS_epoll_wait __NR_epoll_wait
#define SYS_execve __NR_execve
#define SYS_exit __NR_exit
#define SYS_exit_group __NR_exit_group
#define SYS_fchdir __NR_fchdir
#define SYS_fchmod __NR_fchmod
#define SYS_fchown __NR_fchown
#define SYS_fcntl __NR_fcntl
#define SYS_fdatasync __NR_fdatasync
#define SYS_fgetxattr __NR_fgetxattr
#define SYS_flistxattr __NR_flistxattr
#define SYS_flock __NR_flock
#define SYS_fremovexattr __NR_fremovexattr
#define SYS_fsetxattr __NR_fsetxattr
#define SYS_fstat __NR_fstat
#define SYS_fstatfs __NR_fstatfs
#define SYS_fsync __NR_fsync
#define SYS_ftruncate __NR_ftruncate
#define SYS_futex __NR_futex
#define SYS_get_kernel_syms __NR_get_kernel_syms
#define SYS_getcwd __NR_getcwd
#define SYS_getdents __NR_getdents
#define SYS_getdents64 __NR_getdents64
#define SYS_getegid __NR_getegid
#define SYS_geteuid __NR_geteuid
#define SYS_getgid __NR_getgid
#define SYS_getgroups __NR_getgroups
#define SYS_getitimer __NR_getitimer
#define SYS_getpeername __NR_getpeername
#define SYS_getpgid __NR_getpgid
#define SYS_getpid __NR_getpid
#define SYS_getpmsg __NR_getpmsg
#define SYS_getppid __NR_getppid
#define SYS_getpriority __NR_getpriority
#define SYS_getresgid __NR_getresgid
#define SYS_getresuid __NR_getresuid
#define SYS_getrlimit __NR_getrlimit
#define SYS_getrusage __NR_getrusage
#define SYS_getsid __NR_getsid
#define SYS_getsockname __NR_getsockname
#define SYS_getsockopt __NR_getsockopt
#define SYS_gettid __NR_gettid
#define SYS_gettimeofday __NR_gettimeofday
#define SYS_getuid __NR_getuid
#define SYS_getunwind __NR_getunwind
#define SYS_getxattr __NR_getxattr
#define SYS_init_module __NR_init_module
#define SYS_io_cancel __NR_io_cancel
#define SYS_io_destroy __NR_io_destroy
#define SYS_io_getevents __NR_io_getevents
#define SYS_io_setup __NR_io_setup
#define SYS_io_submit __NR_io_submit
#define SYS_ioctl __NR_ioctl
#define SYS_kill __NR_kill
#define SYS_lchown __NR_lchown
#define SYS_lgetxattr __NR_lgetxattr
#define SYS_link __NR_link
#define SYS_listen __NR_listen
#define SYS_listxattr __NR_listxattr
#define SYS_llistxattr __NR_llistxattr
#define SYS_lookup_dcookie __NR_lookup_dcookie
#define SYS_lremovexattr __NR_lremovexattr
#define SYS_lseek __NR_lseek
#define SYS_lsetxattr __NR_lsetxattr
#define SYS_lstat __NR_lstat
#define SYS_madvise __NR_madvise
#define SYS_mincore __NR_mincore
#define SYS_mkdir __NR_mkdir
#define SYS_mknod __NR_mknod
#define SYS_mlock __NR_mlock
#define SYS_mlockall __NR_mlockall
#define SYS_mmap __NR_mmap
#define SYS_mmap2 __NR_mmap2
#define SYS_mount __NR_mount
#define SYS_mprotect __NR_mprotect
#define SYS_mremap __NR_mremap
#define SYS_msgctl __NR_msgctl
#define SYS_msgget __NR_msgget
#define SYS_msgrcv __NR_msgrcv
#define SYS_msgsnd __NR_msgsnd
#define SYS_msync __NR_msync
#define SYS_munlock __NR_munlock
#define SYS_munlockall __NR_munlockall
#define SYS_munmap __NR_munmap
#define SYS_nanosleep __NR_nanosleep
#define SYS_nfsservctl __NR_nfsservctl
#define SYS_ni_syscall __NR_ni_syscall
#define SYS_old_fstat __NR_old_fstat
#define SYS_old_lstat __NR_old_lstat
#define SYS_old_stat __NR_old_stat
#define SYS_open __NR_open
#define SYS_pciconfig_read __NR_pciconfig_read
#define SYS_pciconfig_write __NR_pciconfig_write
#define SYS_perfmonctl __NR_perfmonctl
#define SYS_personality __NR_personality
#define SYS_pipe __NR_pipe
#define SYS_pivot_root __NR_pivot_root
#define SYS_poll __NR_poll
#define SYS_prctl __NR_prctl
#define SYS_pread __NR_pread
#define SYS_ptrace __NR_ptrace
#define SYS_putpmsg __NR_putpmsg
#define SYS_pwrite __NR_pwrite
#define SYS_query_module __NR_query_module
#define SYS_quotactl __NR_quotactl
#define SYS_read __NR_read
#define SYS_readahead __NR_readahead
#define SYS_readlink __NR_readlink
#define SYS_readv __NR_readv
#define SYS_reboot __NR_reboot
#define SYS_recv __NR_recv
#define SYS_recvfrom __NR_recvfrom
#define SYS_recvmsg __NR_recvmsg
#define SYS_removexattr __NR_removexattr
#define SYS_rename __NR_rename
#define SYS_restart_syscall __NR_restart_syscall
#define SYS_rmdir __NR_rmdir
#define SYS_rt_sigaction __NR_rt_sigaction
#define SYS_rt_sigpending __NR_rt_sigpending
#define SYS_rt_sigprocmask __NR_rt_sigprocmask
#define SYS_rt_sigqueueinfo __NR_rt_sigqueueinfo
#define SYS_rt_sigreturn __NR_rt_sigreturn
#define SYS_rt_sigsuspend __NR_rt_sigsuspend
#define SYS_rt_sigtimedwait __NR_rt_sigtimedwait
#define SYS_sched_get_priority_max __NR_sched_get_priority_max
#define SYS_sched_get_priority_min __NR_sched_get_priority_min
#define SYS_sched_getaffinity __NR_sched_getaffinity
#define SYS_sched_getparam __NR_sched_getparam
#define SYS_sched_getscheduler __NR_sched_getscheduler
#define SYS_sched_rr_get_interval __NR_sched_rr_get_interval
#define SYS_sched_setaffinity __NR_sched_setaffinity
#define SYS_sched_setparam __NR_sched_setparam
#define SYS_sched_setscheduler __NR_sched_setscheduler
#define SYS_sched_yield __NR_sched_yield
#define SYS_select __NR_select
#define SYS_semctl __NR_semctl
#define SYS_semget __NR_semget
#define SYS_semop __NR_semop
#define SYS_semtimedop __NR_semtimedop
#define SYS_send __NR_send
#define SYS_sendfile __NR_sendfile
#define SYS_sendmsg __NR_sendmsg
#define SYS_sendto __NR_sendto
#define SYS_set_tid_address __NR_set_tid_address
#define SYS_setdomainname __NR_setdomainname
#define SYS_setfsgid __NR_setfsgid
#define SYS_setfsuid __NR_setfsuid
#define SYS_setgid __NR_setgid
#define SYS_setgroups __NR_setgroups
#define SYS_sethostname __NR_sethostname
#define SYS_setitimer __NR_setitimer
#define SYS_setpgid __NR_setpgid
#define SYS_setpriority __NR_setpriority
#define SYS_setregid __NR_setregid
#define SYS_setresgid __NR_setresgid
#define SYS_setresuid __NR_setresuid
#define SYS_setreuid __NR_setreuid
#define SYS_setrlimit __NR_setrlimit
#define SYS_setsid __NR_setsid
#define SYS_setsockopt __NR_setsockopt
#define SYS_settimeofday __NR_settimeofday
#define SYS_setuid __NR_setuid
#define SYS_setxattr __NR_setxattr
#define SYS_shmat __NR_shmat
#define SYS_shmctl __NR_shmctl
#define SYS_shmdt __NR_shmdt
#define SYS_shmget __NR_shmget
#define SYS_shutdown __NR_shutdown
#define SYS_sigaltstack __NR_sigaltstack
#define SYS_socket __NR_socket
#define SYS_socketpair __NR_socketpair
#define SYS_stat __NR_stat
#define SYS_statfs __NR_statfs
#define SYS_swapoff __NR_swapoff
#define SYS_swapon __NR_swapon
#define SYS_symlink __NR_symlink
#define SYS_sync __NR_sync
#define SYS_sysfs __NR_sysfs
#define SYS_sysinfo __NR_sysinfo
#define SYS_syslog __NR_syslog
#define SYS_tgkill __NR_tgkill
#define SYS_times __NR_times
#define SYS_tkill __NR_tkill
#define SYS_truncate __NR_truncate
#define SYS_umask __NR_umask
#define SYS_umount __NR_umount
#define SYS_uname __NR_uname
#define SYS_unlink __NR_unlink
#define SYS_uselib __NR_uselib
#define SYS_ustat __NR_ustat
#define SYS_utimes __NR_utimes
#define SYS_vhangup __NR_vhangup
#define SYS_vm86 __NR_vm86
#define SYS_wait4 __NR_wait4
#define SYS_write __NR_write
#define SYS_writev __NR_writev
#define SYS_timer_create __NR_timer_create
#define SYS_timer_delete __NR_timer_delete
#define SYS_timer_getoverrun __NR_timer_getoverrun
#define SYS_timer_gettime __NR_timer_gettime
#define SYS_timer_settime __NR_timer_settime
#define SYS_clock_getres __NR_clock_getres
#define SYS_clock_gettime __NR_clock_gettime
#define SYS_clock_nanosleep __NR_clock_nanosleep
#define SYS_clock_settime __NR_clock_settime
#define SYS_fstatfs64 __NR_fstatfs64
#define SYS_fadvise64 __NR_fadvise64

#ifndef __ASSEMBLER__

#define NULL	((void*)0)

/* from asm/errno.h */
#define	EPERM		 1	/* Operation not permitted */
#define	ENOENT		 2	/* No such file or directory */
#define	ESRCH		 3	/* No such process */
#define	EINTR		 4	/* Interrupted system call */
#define	EIO		 5	/* I/O error */
#define	ENXIO		 6	/* No such device or address */
#define	E2BIG		 7	/* Arg list too long */
#define	ENOEXEC		 8	/* Exec format error */
#define	EBADF		 9	/* Bad file number */
#define	ECHILD		10	/* No child processes */
#define	EAGAIN		11	/* Try again */
#define	ENOMEM		12	/* Out of memory */
#define	EACCES		13	/* Permission denied */
#define	EFAULT		14	/* Bad address */
#define	ENOTBLK		15	/* Block device required */
#define	EBUSY		16	/* Device or resource busy */
#define	EEXIST		17	/* File exists */
#define	EXDEV		18	/* Cross-device link */
#define	ENODEV		19	/* No such device */
#define	ENOTDIR		20	/* Not a directory */
#define	EISDIR		21	/* Is a directory */
#define	EINVAL		22	/* Invalid argument */
#define	ENFILE		23	/* File table overflow */
#define	EMFILE		24	/* Too many open files */
#define	ENOTTY		25	/* Not a typewriter */
#define	ETXTBSY		26	/* Text file busy */
#define	EFBIG		27	/* File too large */
#define	ENOSPC		28	/* No space left on device */
#define	ESPIPE		29	/* Illegal seek */
#define	EROFS		30	/* Read-only file system */
#define	EMLINK		31	/* Too many links */
#define	EPIPE		32	/* Broken pipe */
#define	EDOM		33	/* Math argument out of domain of func */
#define	ERANGE		34	/* Math result not representable */
#define	EDEADLK		35	/* Resource deadlock would occur */
#define	ENAMETOOLONG	36	/* File name too long */
#define	ENOLCK		37	/* No record locks available */
#define	ENOSYS		38	/* Function not implemented */
#define	ENOTEMPTY	39	/* Directory not empty */
#define	ELOOP		40	/* Too many symbolic links encountered */
#define	EWOULDBLOCK	EAGAIN	/* Operation would block */
#define	ENOMSG		42	/* No message of desired type */
#define	EIDRM		43	/* Identifier removed */
#define	ECHRNG		44	/* Channel number out of range */
#define	EL2NSYNC	45	/* Level 2 not synchronized */
#define	EL3HLT		46	/* Level 3 halted */
#define	EL3RST		47	/* Level 3 reset */
#define	ELNRNG		48	/* Link number out of range */
#define	EUNATCH		49	/* Protocol driver not attached */
#define	ENOCSI		50	/* No CSI structure available */
#define	EL2HLT		51	/* Level 2 halted */
#define	EBADE		52	/* Invalid exchange */
#define	EBADR		53	/* Invalid request descriptor */
#define	EXFULL		54	/* Exchange full */
#define	ENOANO		55	/* No anode */
#define	EBADRQC		56	/* Invalid request code */
#define	EBADSLT		57	/* Invalid slot */
#define	EDEADLOCK	EDEADLK
#define	EBFONT		59	/* Bad font file format */
#define	ENOSTR		60	/* Device not a stream */
#define	ENODATA		61	/* No data available */
#define	ETIME		62	/* Timer expired */
#define	ENOSR		63	/* Out of streams resources */
#define	ENONET		64	/* Machine is not on the network */
#define	ENOPKG		65	/* Package not installed */
#define	EREMOTE		66	/* Object is remote */
#define	ENOLINK		67	/* Link has been severed */
#define	EADV		68	/* Advertise error */
#define	ESRMNT		69	/* Srmount error */
#define	ECOMM		70	/* Communication error on send */
#define	EPROTO		71	/* Protocol error */
#define	EMULTIHOP	72	/* Multihop attempted */
#define	EDOTDOT		73	/* RFS specific error */
#define	EBADMSG		74	/* Not a data message */
#define	EOVERFLOW	75	/* Value too large for defined data type */
#define	ENOTUNIQ	76	/* Name not unique on network */
#define	EBADFD		77	/* File descriptor in bad state */
#define	EREMCHG		78	/* Remote address changed */
#define	ELIBACC		79	/* Can not access a needed shared library */
#define	ELIBBAD		80	/* Accessing a corrupted shared library */
#define	ELIBSCN		81	/* .lib section in a.out corrupted */
#define	ELIBMAX		82	/* Attempting to link in too many shared libraries */
#define	ELIBEXEC	83	/* Cannot exec a shared library directly */
#define	EILSEQ		84	/* Illegal byte sequence */
#define	ERESTART	85	/* Interrupted system call should be restarted */
#define	ESTRPIPE	86	/* Streams pipe error */
#define	EUSERS		87	/* Too many users */
#define	ENOTSOCK	88	/* Socket operation on non-socket */
#define	EDESTADDRREQ	89	/* Destination address required */
#define	EMSGSIZE	90	/* Message too long */
#define	EPROTOTYPE	91	/* Protocol wrong type for socket */
#define	ENOPROTOOPT	92	/* Protocol not available */
#define	EPROTONOSUPPORT	93	/* Protocol not supported */
#define	ESOCKTNOSUPPORT	94	/* Socket type not supported */
#define	EOPNOTSUPP	95	/* Operation not supported on transport endpoint */
#define	EPFNOSUPPORT	96	/* Protocol family not supported */
#define	EAFNOSUPPORT	97	/* Address family not supported by protocol */
#define	EADDRINUSE	98	/* Address already in use */
#define	EADDRNOTAVAIL	99	/* Cannot assign requested address */
#define	ENETDOWN	100	/* Network is down */
#define	ENETUNREACH	101	/* Network is unreachable */
#define	ENETRESET	102	/* Network dropped connection because of reset */
#define	ECONNABORTED	103	/* Software caused connection abort */
#define	ECONNRESET	104	/* Connection reset by peer */
#define	ENOBUFS		105	/* No buffer space available */
#define	EISCONN		106	/* Transport endpoint is already connected */
#define	ENOTCONN	107	/* Transport endpoint is not connected */
#define	ESHUTDOWN	108	/* Cannot send after transport endpoint shutdown */
#define	ETOOMANYREFS	109	/* Too many references: cannot splice */
#define	ETIMEDOUT	110	/* Connection timed out */
#define	ECONNREFUSED	111	/* Connection refused */
#define	EHOSTDOWN	112	/* Host is down */
#define	EHOSTUNREACH	113	/* No route to host */
#define	EALREADY	114	/* Operation already in progress */
#define	EINPROGRESS	115	/* Operation now in progress */
#define	ESTALE		116	/* Stale NFS file handle */
#define	EUCLEAN		117	/* Structure needs cleaning */
#define	ENOTNAM		118	/* Not a XENIX named type file */
#define	ENAVAIL		119	/* No XENIX semaphores available */
#define	EISNAM		120	/* Is a named type file */
#define	EREMOTEIO	121	/* Remote I/O error */
#define	EDQUOT		122	/* Quota exceeded */
#define	ENOMEDIUM	123	/* No medium found */
#define	EMEDIUMTYPE	124	/* Wrong medium type */

/* from linux/errno.h */
#define ERESTARTSYS     512
#define ERESTARTNOINTR  513
#define ERESTARTNOHAND  514
#define ENOIOCTLCMD     515
#define ERESTART_RESTARTBLOCK 516
#define EBADHANDLE      521
#define ENOTSYNC        522
#define EBADCOOKIE      523
#define ENOTSUPP        524
#define ETOOSMALL       525
#define ESERVERFAULT    526
#define EBADTYPE        527
#define EJUKEBOX        528
#define EIOCBQUEUED     529

/* from asm/mman.h */
#define PROT_READ       0x1             /* page can be read */
#define PROT_WRITE      0x2             /* page can be written */
#define PROT_EXEC       0x4             /* page can be executed */
#define PROT_NONE       0x0             /* page can not be accessed */

#define MAP_SHARED      0x01            /* Share changes */
#define MAP_PRIVATE     0x02            /* Changes are private */
#define MAP_TYPE        0x0f            /* Mask for type of mapping */
#define MAP_FIXED       0x10            /* Interpret addr exactly */
#define MAP_ANONYMOUS   0x20            /* don't use a file */

#define MAP_GROWSDOWN   0x0100          /* stack-like segment */
#define MAP_GROWSUP     0x0200          /* register stack-like segment */
#define MAP_DENYWRITE   0x0800          /* ETXTBSY */
#define MAP_EXECUTABLE  0x1000          /* mark it as an executable */
#define MAP_LOCKED      0x2000          /* pages are locked */
#define MAP_NORESERVE   0x4000          /* don't check for reservations */
#define MAP_WRITECOMBINED 0x10000       /* write-combine the area */
#define MAP_NONCACHED   0x20000         /* don't cache the memory */
#define MAP_ANON        MAP_ANONYMOUS
#define MAP_FILE        0

#define MS_ASYNC        1               /* sync memory asynchronously */
#define MS_INVALIDATE   2               /* invalidate the caches */
#define MS_SYNC         4               /* synchronous memory sync */

#define MCL_CURRENT     1               /* lock all current mappings */
#define MCL_FUTURE      2               /* lock all future mappings */

#define MADV_NORMAL     0x0             /* default page-in behavior */
#define MADV_RANDOM     0x1             /* page-in minimum required */
#define MADV_SEQUENTIAL 0x2             /* read-ahead aggressively */
#define MADV_WILLNEED   0x3             /* pre-fault pages */
#define MADV_DONTNEED   0x4             /* discard these pages */

/* from bits/sigaction.h */
#define SIG_BLOCK          0    /* for blocking signals */
#define SIG_UNBLOCK        1    /* for unblocking signals */
#define SIG_SETMASK        2    /* for setting the signal mask */

/* from stdarg.h */
typedef __builtin_va_list va_list;
#define va_start(v,l)   __builtin_stdarg_start((v),l)
#define va_end          __builtin_va_end
#define va_arg          __builtin_va_arg

/* from bits/types.h */
typedef unsigned short int uint16_t;
typedef unsigned int uint32_t;
typedef unsigned long int uint64_t;
typedef unsigned long int uintptr_t;

typedef long unsigned int size_t;
typedef unsigned long int u_long;

typedef unsigned long int __dev_t;
typedef unsigned int __uid_t;
typedef unsigned int __gid_t;
typedef unsigned long int __ino_t;
typedef unsigned int __mode_t;
typedef unsigned long int __nlink_t;
typedef long int __off_t;
typedef long int __off64_t;
typedef int __pid_t;
typedef struct { int __val[2]; } __fsid_t;
typedef long int __clock_t;
typedef unsigned long int __rlim_t;
typedef long int __time_t;
typedef long int __suseconds_t;
typedef int __daddr_t;
typedef int __key_t;
typedef long int __blksize_t;
typedef long int __blkcnt_t;
typedef long int __ssize_t;
typedef char *__caddr_t;
typedef unsigned int __socklen_t;
typedef __dev_t dev_t;
typedef __gid_t gid_t;
typedef __uid_t uid_t;
typedef __off_t off_t;
typedef __pid_t pid_t;
typedef __ssize_t ssize_t;
typedef __caddr_t caddr_t;
typedef __key_t key_t;
typedef __mode_t mode_t;
typedef __clock_t clock_t;
typedef __time_t time_t;
typedef __off64_t __loff_t;

typedef unsigned long int ulong;

/* from sys/types.h */
typedef __loff_t loff_t;

/* from bits/sigset.h */
# define _SIGSET_NWORDS (1024 / (8 * sizeof (unsigned long int)))

typedef struct {
	unsigned long int __val[_SIGSET_NWORDS];
} __sigset_t;

/* from bits/typesizes.h */
#define  __FD_SETSIZE            1024

/* from sys/select.h */
typedef __sigset_t sigset_t;
typedef long int __fd_mask;
#define __NFDBITS       (8 * sizeof (__fd_mask))

typedef struct {
	__fd_mask fds_bits[__FD_SETSIZE / __NFDBITS];
} fd_set;

/* from linux/time.h */
struct timespec {
	__time_t tv_sec;
	long int tv_nsec;
};

struct timeval {
	__time_t tv_sec;
	__suseconds_t tv_usec;
};

struct itimerspec {
	struct timespec it_interval;
	struct timespec it_value;
};

/* from bits/socket.h */
typedef __socklen_t socklen_t;

/* from signal.h */
typedef void (*__sighandler_t) (int);
typedef __sighandler_t sighandler_t;
typedef __sighandler_t sig_t;

/* from  bits/siginfo.h */
typedef union sigval {
	int sival_int;
	void *sival_ptr;
} sigval_t;

#define __SI_MAX_SIZE     128
#define __SI_PAD_SIZE     ((__SI_MAX_SIZE / sizeof (int)) - 4)

typedef struct siginfo {
	int si_signo;
	int si_errno;
	int si_code;
	int __pad0;
	union {
		int _pad[__SI_PAD_SIZE];
		struct {
			__pid_t si_pid;
			__uid_t si_uid;
		} _kill;
		struct {
			int si_tid;
			int si_overrun;
			sigval_t si_sigval;
		} _timer;
		struct {
			__pid_t si_pid;
			__uid_t si_uid;
			sigval_t si_sigval;
		} _rt;
		struct {
			__pid_t si_pid;
			__uid_t si_uid;
			int si_status;
			__clock_t si_utime;
			__clock_t si_stime;
		} _sigchld;
		struct {
			void *si_addr;
			int _si_imm;
			int _si_pad0;
			unsigned long int _si_isr;
		} _sigfault;
		struct  {
			long int si_band;
			int si_fd;
		} _sigpoll;
	} _sifields;
} siginfo_t;

#define si_pid         _sifields._kill.si_pid
#define si_uid         _sifields._kill.si_uid
#define si_timerid     _sifields._timer.si_tid
#define si_overrun     _sifields._timer.si_overrun
#define si_status      _sifields._sigchld.si_status
#define si_utime       _sifields._sigchld.si_utime
#define si_stime       _sifields._sigchld.si_stime
#define si_value       _sifields._rt.si_sigval
#define si_int         _sifields._rt.si_sigval.sival_int
#define si_ptr         _sifields._rt.si_sigval.sival_ptr
#define si_addr        _sifields._sigfault.si_addr
#define si_band        _sifields._sigpoll.si_band
#define si_fd          _sifields._sigpoll.si_fd
#define si_imm         _sifields._sigfault._si_imm
#define si_isr         _sifields._sigfault._si_isr

enum {
	SI_ASYNCNL = -60,
	SI_TKILL = -6,
	SI_SIGIO,
	SI_ASYNCIO,
	SI_MESGQ,
	SI_TIMER,
	SI_QUEUE,
	SI_USER,
	SI_KERNEL = 0x80
};

enum {
	ILL_ILLOPC = 1,
	ILL_ILLOPN,
	ILL_ILLADR,
	ILL_ILLTRP,
	ILL_PRVOPC,
	ILL_PRVREG,
	ILL_COPROC,
	ILL_BADSTK,
	ILL_BADIADDR,
	ILL_BREAK
};

enum {
	FPE_INTDIV = 1,
	FPE_INTOVF,
	FPE_FLTDIV,
	FPE_FLTOVF,
	FPE_FLTUND,
	FPE_FLTRES,
	FPE_FLTINV,
	FPE_FLTSUB,
	FPE_DECOVF,
	FPE_DECDIV,
	FPE_DECERR,
	FPE_INVASC,
	FPE_INVDEC
};

enum {
	BUS_ADRALN = 1,
	BUS_ADRERR,
	BUS_OBJERR
};

enum {
	TRAP_BRKPT = 1,
	TRAP_TRACE,
	TRAP_BRANCH,
	TRAP_HWBKPT
};

#define __SIGEV_MAX_SIZE       64
#define __SIGEV_PAD_SIZE       ((__SIGEV_MAX_SIZE / sizeof (int)) - 4)

typedef struct sigevent {
	sigval_t sigev_value;
	int sigev_signo;
	int sigev_notify;

	union {
		int _pad[__SIGEV_PAD_SIZE];
		struct {
			void (*_function) (sigval_t);
			void *_attribute;
		} _sigev_thread;
	} _sigev_un;
} sigevent_t;

/* from  bits/sigaction.h */
struct sigaction {
	union {
		__sighandler_t sa_handler;
		void (*sa_sigaction) (int, siginfo_t *, void *);
#define sa_handler     __sigaction_handler.sa_handler
#define sa_sigaction   __sigaction_handler.sa_sigaction
	}
	__sigaction_handler;
	unsigned long int sa_flags;
	__sigset_t sa_mask;
};

struct sigvec {
	__sighandler_t sv_handler;
	int sv_mask;
	int sv_flags;
};

typedef unsigned int umode_t;

/* from asm/types.h */
typedef unsigned char __u8;
typedef char __s8;

typedef unsigned short __u16;
typedef short __s16;

typedef unsigned int __u32;
typedef int __s32;

typedef unsigned long __u64;
typedef long __s64;

/* from asm/fpu.h */
struct ia64_fpreg {
	union {
		unsigned long bits[2];
	} u;
} __attribute__ ((aligned (16)));

/* from  bits/sigstack.h */
struct sigstack {
	void * ss_sp;
	int ss_onstack;
};

enum {
	SS_ONSTACK = 1,
#define SS_ONSTACK	SS_ONSTACK 
	SS_DISABLE
#define SS_DISABLE	SS_DISABLE 
};

#define MINSIGSTKSZ	131027	
	
#define SIGSTKSZ	262144	

typedef struct sigaltstack {
	void * ss_sp;
	int ss_flags;
	size_t ss_size;
} stack_t;

/* from  bits/sigcontext.h */
struct sigcontext {
	unsigned long int sc_flags;
	unsigned long int sc_nat;
	stack_t sc_stack;
	unsigned long int sc_ip;
	unsigned long int sc_cfm;
	unsigned long int sc_um;
	unsigned long int sc_ar_rsc;
	unsigned long int sc_ar_bsp;
	unsigned long int sc_ar_rnat;
	unsigned long int sc_ar_ccv;
	unsigned long int sc_ar_unat;
	unsigned long int sc_ar_fpsr;
	unsigned long int sc_ar_pfs;
	unsigned long int sc_ar_lc;
	unsigned long int sc_pr;
	unsigned long int sc_br[8];
	unsigned long int sc_gr[32];
	struct ia64_fpreg sc_fr[128];
	unsigned long int sc_rbs_base;
	unsigned long int sc_loadrs;
	unsigned long int sc_ar25;
	unsigned long int sc_ar26;
	unsigned long int sc_rsvd[12];
	unsigned long int sc_mask;
};

/* from bits/sched.h */
typedef unsigned long int __cpu_mask;
#define __CPU_SETSIZE  1024
#define __NCPUBITS     (8 * sizeof (__cpu_mask))

typedef struct {
	__cpu_mask __bits[__CPU_SETSIZE / __NCPUBITS];
} cpu_set_t;

#define __CPUELT(cpu)  ((cpu) / __NCPUBITS)
#define __CPUMASK(cpu) ((__cpu_mask) 1 << ((cpu) % __NCPUBITS))

#define __CPU_ZERO(cpusetp)				\
	do {									\
		unsigned int __i;					\
		cpu_set_t *__arr = (cpusetp);		\
		for (__i = 0; __i < sizeof (cpu_set_t) / sizeof (__cpu_mask); ++__i)	\
			__arr->__bits[__i] = 0;			\
	} while (0)
#define __CPU_SET(cpu, cpusetp)			\
	((cpusetp)->__bits[__CPUELT (cpu)] |= __CPUMASK (cpu))
#define __CPU_ISSET(cpu, cpusetp)		\
  (((cpusetp)->__bits[__CPUELT (cpu)] & __CPUMASK (cpu)) != 0)

/* from asm/unistd.h */
extern long __ia64_syscall (long a0, long a1, long a2, long a3, long a4, long nr);

/* from asm/posix_types.h */
typedef long		__kernel_off_t;
typedef unsigned int	__kernel_uid_t;
typedef unsigned int	__kernel_gid_t;
typedef unsigned int	__kernel_mode_t;
typedef long		__kernel_time_t;
typedef int		__kernel_pid_t;
typedef int		__kernel_daddr_t;

typedef struct {
	int	val[2];
} __kernel_fsid_t;

#define stat64                  stat64_32

#ifdef CLOCKS_PER_SEC
    #undef CLOCKS_PER_SEC
#endif
#define CLOCKS_PER_SEC          HZ

#define SEEK_SET                0   /* Seek from beginning of file.  */
#define SEEK_CUR                1   /* Seek from current position.  */
#define SEEK_END                2   /* Seek from end of file.  */

#ifdef  F_GETLK64
        #undef F_GETLK64
#endif
#define F_GETLK64               12 

#ifdef  F_SETLK64
        #undef F_SETLK64
#endif
#define F_SETLK64               13

#ifdef  F_SETLKW64
        #undef F_SETLKW64
#endif
#define F_SETLKW64              14

#ifndef MREMAP_MAYMOVE
        #define MREMAP_MAYMOVE  1
#endif
#ifndef MREMAP_FIXED_
        #define MREMAP_FIXED    2
#endif

#define UIO_MAXIOV              1024

#define IPC_OLD                 0 
#define IPC_64                  0x0100

#define SI_MAX_SIZE             128 
#define SI_PAD_SIZE             ((SI_MAX_SIZE / sizeof(int)) - 4)

#define MAX_ARG_PAGES           32

/* workaround for suse 2.4.19 */
#ifndef FUTEX_WAIT
#define FUTEX_WAIT              (0)
#endif
#ifndef FUTEX_WAKE
#define FUTEX_WAKE              (1)
#endif

/* from asm/statfs.h */
struct k_statfs {
	long f_type;
	long f_bsize;
	long f_blocks;
	long f_bfree;
	long f_bavail;
	long f_files;
	long f_ffree;
	__kernel_fsid_t f_fsid;
	long f_namelen;
	long f_spare[6];
};

struct ia32_modify_ldt_ldt_s {
	unsigned int entry_number;
	unsigned int base_addr;
	unsigned int limit;
	unsigned int seg_32bit:1;
	unsigned int contents:2;
	unsigned int read_exec_only:1;
	unsigned int limit_in_pages:1;
	unsigned int seg_not_present:1;
	unsigned int useable:1;
};

struct statfs64 {
	__u64 f_type;
	__u64 f_bsize;
	__u64 f_blocks;
	__u64 f_bfree;
	__u64 f_bavail;
	__u64 f_files;
	__u64 f_ffree;
	__kernel_fsid_t f_fsid;
	__u64 f_namelen;
	__u64 f_frsize;
	__u64 f_spare[5];
};

/* needed by async io */
typedef unsigned long aio_ctx_t;

struct io_event {
	unsigned long   data;
	unsigned long   obj;
	long   res;
	long   res2;
};

struct aio_ring {
	unsigned  id;
	unsigned  nr;
	unsigned  head;
	unsigned  tail;

	unsigned  magic;
	unsigned  compat_features;
	unsigned  incompat_features;
	unsigned  header_length;

	struct io_event	  io_events[0];
}; 

/* from asm/shmparam.h */
#define	SHMLBA	(1024*1024)

/* from linux/limits.h */
#define PATH_MAX        4096
#define NAME_MAX         255

/* from linux/dirent.h */
struct dirent { 
	long		d_ino;
	__kernel_off_t	d_off;
	unsigned short	d_reclen;
	char		d_name[256]; /* We must not include limits.h! */
};

/* from linux/net.h */
#define SYS_SOCKET	1		/* sys_socket(2)		*/
#define SYS_BIND	2		/* sys_bind(2)			*/
#define SYS_CONNECT	3		/* sys_connect(2)		*/
#define SYS_LISTEN	4		/* sys_listen(2)		*/
#define SYS_ACCEPT	5		/* sys_accept(2)		*/
#define SYS_GETSOCKNAME	6		/* sys_getsockname(2)		*/
#define SYS_GETPEERNAME	7		/* sys_getpeername(2)		*/
#define SYS_SOCKETPAIR	8		/* sys_socketpair(2)		*/
#define SYS_SEND	9		/* sys_send(2)			*/
#define SYS_RECV	10		/* sys_recv(2)			*/
#define SYS_SENDTO	11		/* sys_sendto(2)		*/
#define SYS_RECVFROM	12		/* sys_recvfrom(2)		*/
#define SYS_SHUTDOWN	13		/* sys_shutdown(2)		*/
#define SYS_SETSOCKOPT	14		/* sys_setsockopt(2)		*/
#define SYS_GETSOCKOPT	15		/* sys_getsockopt(2)		*/
#define SYS_SENDMSG	16		/* sys_sendmsg(2)		*/
#define SYS_RECVMSG	17		/* sys_recvmsg(2)		*/

/* from linux/posix_types.h */
/* Type of a SYSV IPC key.  */
typedef int __kernel_key_t;

/* from linux/shm.h */
/* super user shmctl commands */
#define SHM_LOCK 	11
#define SHM_UNLOCK 	12

/* ipcs ctl commands */
#define SHM_STAT 	13
#define SHM_INFO 	14
# define SEM_STAT 18
# define SEM_INFO 19

/* Commands for `semctl'.  */
#define GETPID		11		/* get sempid */
#define GETVAL		12		/* get semval */
#define GETALL		13		/* get all semval's */
#define GETNCNT		14		/* get semncnt */
#define GETZCNT		15		/* get semzcnt */
#define SETVAL		16		/* set semval */
#define SETALL		17		/* set all semval's */

/* Obsolete, used only for backwards compatibility */
struct	shminfo {
	int shmmax;
	int shmmin;
	int shmmni;
	int shmseg;
	int shmall;
};

struct shm_info {
	int used_ids;
	unsigned long shm_tot;	/* total allocated shm */
	unsigned long shm_rss;	/* total resident shm */
	unsigned long shm_swp;	/* total swapped shm */
	unsigned long swap_attempts;
	unsigned long swap_successes;
};

struct ipc64_perm {
	__kernel_key_t	key;
	__kernel_uid_t	uid;
	__kernel_gid_t	gid;
	__kernel_uid_t	cuid;
	__kernel_gid_t	cgid;
	__kernel_mode_t	mode;
	unsigned short	seq;
	unsigned short	__pad1;
	unsigned long	__unused1;
	unsigned long	__unused2;
};

struct shmid64_ds {
	struct ipc64_perm	shm_perm;	/* operation perms */
	size_t			shm_segsz;	/* size of segment (bytes) */
	__kernel_time_t		shm_atime;	/* last attach time */
	__kernel_time_t		shm_dtime;	/* last detach time */
	__kernel_time_t		shm_ctime;	/* last change time */
	__kernel_pid_t		shm_cpid;	/* pid of creator */
	__kernel_pid_t		shm_lpid;	/* pid of last operator */
	unsigned long		shm_nattch;	/* no. of current attaches */
	unsigned long		__unused1;
	unsigned long		__unused2;
};

struct semid64_ds {
	struct ipc64_perm sem_perm;		/* permissions .. see ipc.h */
	__kernel_time_t	sem_otime;		/* last semop time */
	__kernel_time_t	sem_ctime;		/* last change time */
	unsigned long	sem_nsems;		/* no. of semaphores in array */
	unsigned long	__unused1;
	unsigned long	__unused2;
};

/* from bits/shm.h */
#ifndef SHM_RND 
#define SHM_RND         020000          /* round attach address to SHMLBA */
#define SHM_REMAP       040000          /* take-over region on attach */
#endif

/* from linux/sysctl.h */
struct __sysctl_args {
	int *name;
	int nlen;
	void *oldval;
	size_t *oldlenp;
	void *newval;
	size_t newlen;
	unsigned long __unused[4];
};

/* from linux/ipc.h */
/* 
 * Control commands used with semctl, msgctl and shmctl 
 * see also specific commands in sem.h, msg.h and shm.h
 */
#define IPC_RMID 0     /* remove resource */
#define IPC_SET  1     /* set ipc_perm options */
#define IPC_STAT 2     /* get ipc_perm options */
#define IPC_INFO 3     /* see ipcs */

/* from linux/msg.h */
/* message buffer for msgsnd and msgrcv calls */
struct msgbuf {
	long mtype;         /* type of message */
	char mtext[1];      /* message text */
};
/* ipcs ctl commands */
#define MSG_STAT 11
#define MSG_INFO 12
#define MSGMAX  8192   /* <= INT_MAX */   /* max size of message (bytes) */

/* from asm/msgbuf.h */
struct msqid64_ds {
	struct ipc64_perm msg_perm;
	__kernel_time_t msg_stime;	/* last msgsnd time */
	__kernel_time_t msg_rtime;	/* last msgrcv time */
	__kernel_time_t msg_ctime;	/* last change time */
	unsigned long  msg_cbytes;	/* current number of bytes on queue */
	unsigned long  msg_qnum;	/* number of messages in queue */
	unsigned long  msg_qbytes;	/* max number of bytes on queue */
	__kernel_pid_t msg_lspid;	/* pid of last msgsnd */
	__kernel_pid_t msg_lrpid;	/* last receive pid */
	unsigned long  __unused1;
	unsigned long  __unused2;
};

/* from asm/shmbuf.h */
struct shminfo64 {
	unsigned long	shmmax;
	unsigned long	shmmin;
	unsigned long	shmmni;
	unsigned long	shmseg;
	unsigned long	shmall;
	unsigned long	__unused1;
	unsigned long	__unused2;
	unsigned long	__unused3;
	unsigned long	__unused4;
};

/* from linux/stddef.h */
#undef offsetof
#define offsetof(TYPE, MEMBER) ((size_t) &((TYPE *)0)->MEMBER)

/* from asm/resource.h */
#define IA32_RLIM_INFINITY 0xffffffff
#define LEGACY_IA32_RLIM_INFINITY 0x7fffffff

/* from sys/uio.h */
#define UIO_MAXIOV      1024

struct iovec{
	void *iov_base;     /* Pointer to data.  */
	size_t iov_len;     /* Length of data.  */
};

extern ssize_t readv (int __fd, __const struct iovec *__vector, int __count);
extern ssize_t writev (int __fd, __const struct iovec *__vector, int __count);

/* from bits/fcntl.h */
struct flock{
	short int l_type;
	short int l_whence;
	__off_t l_start;
	__off_t l_len;
	__pid_t l_pid;
};

#define FD_CLOEXEC      1

/* from asm/fcntl.h */
#define F_DUPFD         0       /* dup */
#define F_GETFD         1       /* get close_on_exec */
#define F_SETFD         2       /* set/clear close_on_exec */
#define F_GETFL         3       /* get file->f_flags */
#define F_SETFL         4       /* set file->f_flags */
#define F_GETLK         5
#define F_SETLK         6
#define F_SETLKW        7
#define F_SETOWN        8       /*  for sockets. */
#define F_GETOWN        9       /*  for sockets. */
#define F_SETSIG        10      /*  for sockets. */
#define F_GETSIG        11      /*  for sockets. */

#define O_RDONLY             00
#define O_WRONLY             01
#define O_RDWR               02
#define O_CREAT            0100
#define O_EXCL             0200
#define O_NOCTTY           0400
#define O_TRUNC           01000
#define O_APPEND          02000

/* from bits/stat.h */
struct stat {
	__dev_t st_dev;
	__ino_t st_ino;
	__nlink_t st_nlink;
	__mode_t st_mode;
	__uid_t st_uid;
	__gid_t st_gid;
	int pad0;
	__dev_t st_rdev;
	__off_t st_size;
	struct timespec st_atim;
	struct timespec st_mtim;
	struct timespec st_ctim;
	__blksize_t st_blksize;
	__blkcnt_t st_blocks;
	long int __unused[3];
};
#define st_atime st_atim.tv_sec
#define st_mtime st_mtim.tv_sec
#define st_ctime st_ctim.tv_sec

/* from  asm/signal.h */
#define SIGHUP           1
#define SIGINT           2
#define SIGQUIT          3
#define SIGILL           4
#define SIGTRAP          5
#define SIGABRT          6
#define SIGIOT           6
#define SIGBUS           7
#define SIGFPE           8
#define SIGKILL          9
#define SIGUSR1         10
#define SIGSEGV         11
#define SIGUSR2         12
#define SIGPIPE         13
#define SIGALRM         14
#define SIGTERM         15
#define SIGSTKFLT       16
#define SIGCHLD         17
#define SIGCONT         18
#define SIGSTOP         19
#define SIGTSTP         20
#define SIGTTIN         21
#define SIGTTOU         22
#define SIGURG          23
#define SIGXCPU         24
#define SIGXFSZ         25
#define SIGVTALRM       26
#define SIGPROF         27
#define SIGWINCH        28
#define SIGIO           29
#define SIGPOLL         SIGIO
#define SIGPWR          30
#define SIGSYS          31
#define SIGUNUSED       31

#define SIGRTMIN        32
#define SIGRTMAX        (_NSIG-1)

#define SIG_DFL ((__sighandler_t)0)
#define SIG_IGN ((__sighandler_t)1)

/* SA_FLAGS values */
#define SA_NOCLDSTOP    0x00000001
#define SA_NOCLDWAIT    0x00000002 /* not supported yet */
#define SA_SIGINFO      0x00000004
#define SA_ONSTACK      0x08000000
#define SA_RESTART      0x10000000
#define SA_NODEFER      0x40000000
#define SA_RESETHAND    0x80000000
#define SA_NOMASK       SA_NODEFER
#define SA_ONESHOT      SA_RESETHAND
#define SA_INTERRUPT    0x20000000 /* dummy -- ignored */
#define SA_RESTORER     0x04000000

/* from bits/ioctl-types.h */
struct winsize {
	unsigned short int ws_row;
	unsigned short int ws_col;
	unsigned short int ws_xpixel;
	unsigned short int ws_ypixel;
};

struct termio {
	unsigned short int c_iflag;
	unsigned short int c_oflag;
	unsigned short int c_cflag;
	unsigned short int c_lflag;
	unsigned char c_line;
	unsigned char c_cc[8];
};

/* from bits/socket.h */
struct msghdr {
	void *msg_name;
	socklen_t msg_namelen;
	struct iovec *msg_iov;
	size_t msg_iovlen;
	void *msg_control;
	size_t msg_controllen;
	int msg_flags;
};

struct cmsghdr {
	size_t cmsg_len;
	int cmsg_level;
	int cmsg_type;
	unsigned char __cmsg_data [];
};

extern struct cmsghdr *__cmsg_nxthdr (struct msghdr *__mhdr,
                                      struct cmsghdr *__cmsg) ;

#define CMSG_ALIGN(len) (((len) + sizeof (size_t) - 1) \
	                         & (size_t) ~(sizeof (size_t) - 1))
	
#define CMSG_DATA(cmsg) ((cmsg)->__cmsg_data)
#define CMSG_NXTHDR(mhdr, cmsg) __cmsg_nxthdr (mhdr, cmsg)
#define CMSG_FIRSTHDR(mhdr) \
		((size_t) (mhdr)->msg_controllen >= sizeof (struct cmsghdr)                 \
			? (struct cmsghdr *) (mhdr)->msg_control : (struct cmsghdr *) NULL)

typedef unsigned short int sa_family_t;
struct sockaddr {
	sa_family_t sa_family;
	char sa_data[14];
};

enum {
	SCM_RIGHTS = 0x01,
	SCM_CREDENTIALS = 0x02,
	__SCM_CONNECT = 0x03
};

struct ucred {
	pid_t pid;
	uid_t uid;
	gid_t gid;
};

struct linger {
	int l_onoff;
	int l_linger;
};

struct osockaddr {
	unsigned short int sa_family;
	unsigned char sa_data[14];
};

enum {
	SHUT_RD = 0,
	SHUT_WR,
	SHUT_RDWR
};

/* from  unistd.h */
/* Standard file descriptors.  */
#define STDIN_FILENO    0       /* Standard input.  */
#define STDOUT_FILENO   1       /* Standard output.  */
#define STDERR_FILENO   2       /* Standard error output.  */

/* from stdio.h */
typedef struct _IO_FILE FILE;

extern FILE *fopen (__const char *__restrict __filename,
			__const char *__restrict __modes);

/* from  asm/ioctl.h */
#define _IOC_NRBITS     8
#define _IOC_TYPEBITS   8
#define _IOC_SIZEBITS   14
#define _IOC_DIRBITS    2

#define _IOC_NRSHIFT    0
#define _IOC_TYPESHIFT  (_IOC_NRSHIFT+_IOC_NRBITS)
#define _IOC_SIZESHIFT  (_IOC_TYPESHIFT+_IOC_TYPEBITS)
#define _IOC_DIRSHIFT   (_IOC_SIZESHIFT+_IOC_SIZEBITS)

#define _IOC_NONE       0U
#define _IOC_WRITE      1U
#define _IOC_READ       2U

#define _IOC(dir,type,nr,size) \
		(((dir)  << _IOC_DIRSHIFT) | \
		((type) << _IOC_TYPESHIFT) | \
		((nr)   << _IOC_NRSHIFT) | \
		((size) << _IOC_SIZESHIFT))

/* used to create numbers */
#define _IO(type,nr)            _IOC(_IOC_NONE,(type),(nr),0)
#define _IOR(type,nr,size)      _IOC(_IOC_READ,(type),(nr),sizeof(size))
#define _IOW(type,nr,size)      _IOC(_IOC_WRITE,(type),(nr),sizeof(size))
#define _IOWR(type,nr,size)     _IOC(_IOC_READ|_IOC_WRITE,(type),(nr),sizeof(size))
	
/* from  bits/ioctls.h */
#define SIOCGIFCONF       0x8912

/* from  linux/kernel.h */
struct sysinfo {
	long uptime;           
	unsigned long loads[3]; 
	unsigned long totalram; 
	unsigned long freeram;  
	unsigned long sharedram;
	unsigned long bufferram;
	unsigned long totalswap;
	unsigned long freeswap; 
	unsigned short procs;   
	unsigned short pad;     
	unsigned long totalhigh;
	unsigned long freehigh; 
	unsigned int mem_unit;  
	char _f[20-2*sizeof(long)-sizeof(int)];
};

/* from bits/utsname.h */
#define _UTSNAME_LENGTH 65
#define _UTSNAME_DOMAIN_LENGTH _UTSNAME_LENGTH

/* from sys/utsname.h */
#define _UTSNAME_SYSNAME_LENGTH _UTSNAME_LENGTH
#define _UTSNAME_NODENAME_LENGTH _UTSNAME_LENGTH
#define _UTSNAME_RELEASE_LENGTH _UTSNAME_LENGTH
#define _UTSNAME_VERSION_LENGTH _UTSNAME_LENGTH
#define _UTSNAME_MACHINE_LENGTH _UTSNAME_LENGTH

struct utsname {
	char sysname[_UTSNAME_SYSNAME_LENGTH];
	char nodename[_UTSNAME_NODENAME_LENGTH];
	char release[_UTSNAME_RELEASE_LENGTH];
	char version[_UTSNAME_VERSION_LENGTH];
	char machine[_UTSNAME_MACHINE_LENGTH];
	char domainname[_UTSNAME_DOMAIN_LENGTH];
};

/* from sys/epoll.h */
typedef union epoll_data {
	void *ptr;
	int fd;
	uint32_t u32;
	uint64_t u64;
} epoll_data_t;

struct epoll_event {
	uint32_t events;
	epoll_data_t data;
};

/* from bits/resource.h */
struct rusage {
	struct timeval ru_utime;
	struct timeval ru_stime;
	long int ru_maxrss;
	long int ru_ixrss;
	long int ru_idrss;
	long int ru_isrss;
	long int ru_minflt;
	long int ru_majflt;
	long int ru_nswap;
	long int ru_inblock;
	long int ru_oublock;
	long int ru_msgsnd;
	long int ru_msgrcv;
	long int ru_nsignals;
	long int ru_nvcsw;
	long int ru_nivcsw;
};

enum __priority_which {
	PRIO_PROCESS = 0,
	PRIO_PGRP = 1,
	PRIO_USER = 2
};
typedef __rlim_t rlim_t;

struct rlimit {
	rlim_t rlim_cur;
	rlim_t rlim_max;
};

enum __rlimit_resource {
	RLIMIT_CPU = 0,
#define RLIMIT_CPU RLIMIT_CPU
	RLIMIT_FSIZE = 1,
#define	RLIMIT_FSIZE RLIMIT_FSIZE
	RLIMIT_DATA = 2,
#define	RLIMIT_DATA RLIMIT_DATA
	RLIMIT_STACK = 3,
#define	RLIMIT_STACK RLIMIT_STACK
	RLIMIT_CORE = 4,
#define	RLIMIT_CORE RLIMIT_CORE
	RLIMIT_RSS = 5,
#define	RLIMIT_RSS RLIMIT_RSS
	RLIMIT_NOFILE = 7,
	RLIMIT_OFILE = RLIMIT_NOFILE,
#define RLIMIT_NOFILE RLIMIT_NOFILE
#define RLIMIT_OFILE RLIMIT_OFILE
	RLIMIT_AS = 9,
#define RLIMIT_AS RLIMIT_AS
	RLIMIT_NPROC = 6,
#define RLIMIT_NPROC RLIMIT_NPROC
	RLIMIT_MEMLOCK = 8,
#define RLIMIT_MEMLOCK RLIMIT_MEMLOCK
	RLIMIT_LOCKS = 10,
#define RLIMIT_LOCKS RLIMIT_LOCKS
	RLIMIT_NLIMITS = 11,
	RLIM_NLIMITS = RLIMIT_NLIMITS
#define RLIMIT_NLIMITS RLIMIT_NLIMITS
#define RLIM_NLIMITS RLIM_NLIMITS
};

#define RLIM_INFINITY  (~0UL)

/* from sys/personality.h */
enum {
	MMAP_PAGE_ZERO =        0x0100000,
	READ_IMPLIES_EXEC =     0x0400000,
	ADDR_LIMIT_32BIT =      0x0800000,
	SHORT_INODE =           0x1000000,
	WHOLE_SECONDS =         0x2000000,
	STICKY_TIMEOUTS =       0x4000000,
	ADDR_LIMIT_3GB =        0x8000000,
};
	
/* Personality types */
enum {
	PER_LINUX = 0x0000,
	PER_LINUX_32BIT = 0x0000 | ADDR_LIMIT_32BIT,
	PER_SVR4 = 0x0001 | STICKY_TIMEOUTS | MMAP_PAGE_ZERO,
	PER_SVR3 = 0x0002 | STICKY_TIMEOUTS | SHORT_INODE,
	PER_SCOSVR3 = 0x0003 | STICKY_TIMEOUTS | WHOLE_SECONDS | SHORT_INODE,
	PER_OSR5 = 0x0003 | STICKY_TIMEOUTS | WHOLE_SECONDS,
	PER_WYSEV386 = 0x0004 | STICKY_TIMEOUTS | SHORT_INODE,
	PER_ISCR4 = 0x0005 | STICKY_TIMEOUTS,
	PER_BSD = 0x0006,
	PER_SUNOS = 0x0006 | STICKY_TIMEOUTS,
	PER_XENIX = 0x0007 | STICKY_TIMEOUTS | SHORT_INODE,
	PER_LINUX32 = 0x0008,
	PER_IRIX32 = 0x0009 | STICKY_TIMEOUTS,      /* IRIX5 32-bit */
	PER_IRIXN32 = 0x000a | STICKY_TIMEOUTS,     /* IRIX6 new 32-bit */
	PER_IRIX64 = 0x000b | STICKY_TIMEOUTS,      /* IRIX6 64-bit */
	PER_RISCOS = 0x000c,
	PER_SOLARIS = 0x000d | STICKY_TIMEOUTS,
	PER_UW7 = 0x000e | STICKY_TIMEOUTS | MMAP_PAGE_ZERO,
	PER_HPUX = 0x000f,
	PER_OSF4 = 0x0010,
	PER_MASK = 0x00ff,
};

/* from  asm/param.h */
#define NGROUPS    32
#define HZ     1024

/* from  sys/time.h */
enum __itimer_which {
	ITIMER_REAL = 0,
#define ITIMER_REAL ITIMER_REAL
	ITIMER_VIRTUAL = 1,
#define ITIMER_VIRTUAL ITIMER_VIRTUAL
	ITIMER_PROF = 2
#define ITIMER_PROF ITIMER_PROF
};

struct itimerval {
	struct timeval it_interval;
	struct timeval it_value;
};

/* from sys/times.h */
struct tms {
	clock_t tms_utime;
	clock_t tms_stime;
	clock_t tms_cutime;
	clock_t tms_cstime;
};

/* from sys/timex.h */
struct timex {
	unsigned int modes;
	long int offset;
	long int freq;
	long int maxerror;
	long int esterror;
	int status;
	long int constant;
	long int precision;
	long int tolerance;
	struct timeval time;
	long int tick;
	long int ppsfreq;
	long int jitter;
	int shift;
	long int stabil;
	long int jitcnt;
	long int calcnt;
	long int errcnt;
	long int stbcnt;
	int :32; int :32; int :32; int :32;
	int :32; int :32; int :32; int :32;
	int :32; int :32; int :32; int :32;
};

/* from  limits.h */
#define INT_MAX      2147483647

/* from  linux/limits.h */
#define NR_OPEN          1024

/* from linux/prctl.h */
#define PR_SET_UNALIGN    6
#define PR_UNALIGN_NOPRINT     1

/* from  bits/signum.h */
#define _NSIG           65

/* from  asm/ptrace_offsets.h */
#define PT_R13                     0x08a8
#define PT_AR_BSP               0x0880ul

/* from sys/ptrace.h */
enum __ptrace_request{
	PTRACE_TRACEME = 0,
	PTRACE_PEEKTEXT = 1,
	PTRACE_PEEKDATA = 2,
	PTRACE_PEEKUSER = 3,
	PTRACE_POKETEXT = 4,
	PTRACE_POKEDATA = 5,
	PTRACE_POKEUSER = 6,
	PTRACE_CONT = 7,
	PTRACE_KILL = 8,
	PTRACE_SINGLESTEP = 9,
	PTRACE_SINGLEBLOCK = 12,
	PTRACE_OLD_GETSIGINFO = 13,
	PTRACE_OLD_SETSIGINFO = 14,
	PTRACE_ATTACH = 16,
	PTRACE_DETACH = 17,
	PTRACE_SYSCALL = 24
};
enum __ptraceX_request {
	PTRACE_SETOPTIONS = 0x4200,
	PTRACE_GETEVENTMSG,
	PTRACE_GETSIGINFO,
	PTRACE_SETSIGINFO
};

/* from linux/ptrace.h */
/* options set using PTRACE_SETOPTIONS */
#define PTRACE_O_TRACESYSGOOD   0x00000001
#define PTRACE_O_TRACEFORK      0x00000002
#define PTRACE_O_TRACEVFORK     0x00000004
#define PTRACE_O_TRACECLONE     0x00000008
#define PTRACE_O_TRACEEXEC      0x00000010
#define PTRACE_O_TRACEVFORKDONE 0x00000020
#define PTRACE_O_TRACEEXIT      0x00000040


/* from asm/ptrace.h */
struct pt_all_user_regs {
	unsigned long nat;
	unsigned long cr_iip;
	unsigned long cfm;
	unsigned long cr_ipsr;
	unsigned long pr;
	unsigned long gr[32];
	unsigned long br[8];
	unsigned long ar[128];
	struct ia64_fpreg fr[128];
};

/* from bits/waitstatus.h */
#define __WIFSTOPPED(status)    (((status) & 0xff) == 0x7f)
#define __WEXITSTATUS(status)   (((status) & 0xff00) >> 8)
#define __WSTOPSIG(status)      __WEXITSTATUS(status)
#define __WTERMSIG(status)      ((status) & 0x7f)
#define __WIFEXITED(status)     (__WTERMSIG(status) == 0)
#define __WIFSIGNALED(status) \
		(__extension__ ({ int __status = (status);	\
			!__WIFSTOPPED(__status) && !__WIFEXITED(__status); }))
#define __W_STOPCODE(sig)       ((sig) << 8 | 0x7f)

/* from  bits/waitflags.h */
#define WNOHANG         1
#define WUNTRACED       2
#define __WALL          0x40000000
#define __WCLONE        0x80000000

/* from  linux/ptrace.h */
#define PTRACE_TRACEME             0
#define PTRACE_PEEKTEXT            1
#define PTRACE_PEEKDATA            2
#define PTRACE_PEEKUSR             3
#define PTRACE_POKETEXT            4
#define PTRACE_POKEDATA            5
#define PTRACE_POKEUSR             6
#define PTRACE_CONT                7
#define PTRACE_KILL                8
#define PTRACE_SINGLESTEP          9
#define PTRACE_ATTACH           0x10
#define PTRACE_DETACH           0x11

/* from  asm/ptrace.h */
#define PT_AUR_RSC      16
#define PT_AUR_BSP      17
#define PT_AUR_BSPSTORE 18
#define PT_AUR_RNAT     19
#define PT_AUR_CCV      32
#define PT_AUR_UNAT     36
#define PT_AUR_FPSR     40
#define PT_AUR_PFS      64
#define PT_AUR_LC       65
#define PT_AUR_EC       66

#define PTRACE_SINGLEBLOCK      12
#define PTRACE_GETSIGINFO       13
#define PTRACE_SETSIGINFO       14
#define PTRACE_GETREGS          18
#define PTRACE_SETREGS          19

/* from asm/rse.h */
static inline unsigned long
ia64_rse_slot_num (unsigned long *addr) {
	return (((unsigned long) addr) >> 3) & 0x3f;
}

static inline unsigned long *
ia64_rse_rnat_addr (unsigned long *slot_addr) {
	return (unsigned long *) ((unsigned long) slot_addr | (0x3f << 3));
}

static inline unsigned long *
ia64_rse_skip_regs (unsigned long *addr, long num_regs) {
	long delta = ia64_rse_slot_num(addr) + num_regs;
	
	if (num_regs < 0)
		delta -= 0x3e;
	return addr + num_regs + delta/0x3f;
}

/* from  bits/sched.h */
#define CSIGNAL       0x000000ff
#define CLONE_VM      0x00000100
#define CLONE_FS      0x00000200
#define CLONE_FILES   0x00000400
#define CLONE_SIGHAND 0x00000800
#define CLONE_PTRACE  0x00002000
#define CLONE_VFORK   0x00004000
#define CLONE_PARENT  0x00008000
#define CLONE_THREAD  0x00010000
#define CLONE_NEWNS   0x00020000
#define CLONE_SYSVSEM 0x00040000
#define CLONE_SETTLS  0x00080000
#define CLONE_PARENT_SETTID 0x00100000 
#define CLONE_CHILD_CLEARTID 0x00200000 
#define CLONE_DETACHED 0x00400000 
#define CLONE_UNTRACED 0x00800000 
#define CLONE_CHILD_SETTID 0x01000000 
#define CLONE_STOPPED  0x02000000 

/* from  elf.h */
#define EM_386		3

#define EI_MAG0		0
#define ELFMAG0         0x7f

#define EI_MAG1         1
#define ELFMAG1         'E'

#define EI_MAG2         2
#define ELFMAG2         'L'

#define EI_MAG3         3
#define ELFMAG3         'F'

#define EI_CLASS        4
#define ELFCLASS32      1

#define EI_DATA         5
#define ELFDATA2LSB     1
#define EI_VERSION      6

#define ELFMAG          "\177ELF"
#define SELFMAG         4

#define ET_EXEC         2
#define ET_DYN          3
#define ET_CORE         4

#define EV_CURRENT      1

#define NT_PRSTATUS     1
#define NT_FPREGSET     2
#define NT_PRPSINFO     3

#define PF_X            (1 << 0)
#define PF_W            (1 << 1)
#define PF_R            (1 << 2)

#define AT_NULL         0               /* End of vector */
#define AT_IGNORE       1               /* Entry should be ignored */
#define AT_EXECFD       2               /* File descriptor of program */
#define AT_PHDR         3               /* Program headers for program */
#define AT_PHENT        4               /* Size of program header entry */
#define AT_PHNUM        5               /* Number of program headers */
#define AT_PAGESZ       6               /* System page size */
#define AT_BASE         7               /* Base address of interpreter */
#define AT_FLAGS        8               /* Flags */
#define AT_ENTRY        9               /* Entry point of program */
#define AT_NOTELF       10              /* Program is not ELF */
#define AT_UID          11              /* Real uid */
#define AT_EUID         12              /* Effective uid */
#define AT_GID          13              /* Real gid */
#define AT_EGID         14              /* Effective gid */
#define AT_PLATFORM     15
#define AT_HWCAP        16
#define AT_CLKTCK       17              /* Frequency of times() */
#define AT_SECURE       23

#define PT_NULL         0               /* Program header table entry unused */
#define PT_LOAD         1               /* Loadable program segment */
#define PT_DYNAMIC      2               /* Dynamic linking information */
#define PT_INTERP       3               /* Program interpreter */
#define PT_NOTE         4               /* Auxiliary information */
#define PT_SHLIB        5               /* Reserved */
#define PT_PHDR         6               /* Entry for header table itself */
#define PT_TLS          7               /* Thread-local storage segment */
#define PT_NUM          8               /* Number of defined types */

#define PT_LOOS    0x60000000
#define PT_GNU_STACK    (PT_LOOS + 0x474e551)

typedef uint32_t Elf64_Word;
typedef uint64_t Elf64_Xword;
typedef uint64_t Elf64_Addr;
typedef uint64_t Elf64_Off;

typedef uint16_t Elf32_Half;
typedef uint32_t Elf32_Word;
typedef uint32_t Elf32_Addr;
typedef uint32_t Elf32_Off;

#define EI_NIDENT 16
typedef struct {
	unsigned char e_ident[EI_NIDENT];
	Elf32_Half e_type;
	Elf32_Half e_machine;
	Elf32_Word e_version;
	Elf32_Addr e_entry;
	Elf32_Off e_phoff;
	Elf32_Off e_shoff;
	Elf32_Word e_flags;
	Elf32_Half e_ehsize;
	Elf32_Half e_phentsize;
	Elf32_Half e_phnum;
	Elf32_Half e_shentsize;
	Elf32_Half e_shnum;
	Elf32_Half e_shstrndx;
} Elf32_Ehdr;

typedef struct {
	Elf32_Word n_namesz;
	Elf32_Word n_descsz;
	Elf32_Word n_type;
} Elf32_Nhdr;

typedef struct {
	Elf32_Word p_type;
	Elf32_Off p_offset;
	Elf32_Addr p_vaddr;
	Elf32_Addr p_paddr;
	Elf32_Word p_filesz;
	Elf32_Word p_memsz;
	Elf32_Word p_flags;
	Elf32_Word p_align;
} Elf32_Phdr;

typedef struct {
	Elf64_Word p_type;
	Elf64_Word p_flags;
	Elf64_Off p_offset;
	Elf64_Addr p_vaddr;
	Elf64_Addr p_paddr;
	Elf64_Xword p_filesz;
	Elf64_Xword p_memsz;
	Elf64_Xword p_align;
} Elf64_Phdr;

/* from  linux/stat.h */
#define S_ISUID  0004000
#define S_ISGID  0002000
#define S_IRWXU 00700
#define S_IRUSR 00400
#define S_IWUSR 00200
#define S_IXUSR 00100

#define S_IRWXG 00070
#define S_IRGRP 00040
#define S_IWGRP 00020
#define S_IXGRP 00010

#define S_IRWXO 00007
#define S_IROTH 00004
#define S_IWOTH 00002
#define S_IXOTH 00001


/* from asm/processor.h */
struct i387_fsave_struct {
	unsigned cwd;
	unsigned swd;
	unsigned twd;
	unsigned fip;
	unsigned fcs;
	unsigned foo;
	unsigned fos;
	unsigned st_space[20];	/* 8*10 bytes for each FP-reg = 80 bytes */
	unsigned status;	/* software status information */
};

struct i387_fxsave_struct {
	unsigned short cwd;
	unsigned short swd;
	unsigned short twd;
	unsigned short fop;
	unsigned fip;
	unsigned fcs;
	unsigned foo;
	unsigned fos;
	unsigned mxcsr;
	unsigned reserved;
	unsigned st_space[32];	/* 8*16 bytes for each FP-reg = 128 bytes */
	unsigned xmm_space[32];	/* 8*16 bytes for each XMM-reg = 128 bytes */
	unsigned padding[56];
} __attribute__ ((aligned (16)));

typedef struct linux_sigcontext {
	unsigned short gs, __gsh;
	unsigned short fs, __fsh;
	unsigned short es, __esh;
	unsigned short ds, __dsh;
	unsigned edi;
	unsigned esi;
	unsigned ebp;
	unsigned esp;
	unsigned ebx;
	unsigned edx;
	unsigned ecx;
	unsigned eax;
	unsigned trapno;
	unsigned err;
	unsigned eip;
	unsigned short cs, __csh;
	unsigned eflags;
	unsigned esp_at_signal;
	unsigned short ss, __ssh;
	unsigned fpstate;	/* IA-32 pointer to struct _fpstate_ia32 */
	unsigned oldmask;
	unsigned cr2;
} sigcontext32_t;

/* from bits/sem.h */
#define SEM_UNDO        0x1000
#define SETALL          17		/* set all semval's */

/* from bits/ipc.h */
#define IPC_RMID        0
#define IPC_CREAT  	00001000	/* create if key is nonexistent */
#define IPC_EXCL   	00002000	/* fail if key exists */

#if DEBUG
struct linux_dirent64 {
	unsigned long d_ino;
	long d_off;
	unsigned short d_reclen;
	unsigned char d_type;
	char d_name[0];
};
#endif

/* from asm/ipc.h */
struct ipc_kludge {
	struct msgbuf *msgp;
	long msgtyp;
};

#define SEMOP		 1
#define SEMGET		 2
#define SEMCTL		 3
#define MSGSND		11
#define MSGRCV		12
#define MSGGET		13
#define MSGCTL		14
#define SHMAT		21
#define SHMDT		22
#define SHMGET		23
#define SHMCTL		24

/* futex */
#ifndef FUTEX_WAIT
#define FUTEX_WAIT (0)
#endif

#ifndef FUTEX_WAKE
#define FUTEX_WAKE (1)
#endif

#ifndef SI_TKILL
# define SI_TKILL -6
#endif

#ifndef SEMTIMEDOP
#define SEMTIMEDOP 4
#endif

/* from bits/socket.h */
#define AF_UNIX 1
#define SOCK_DGRAM 2

/* from sys/syslog.h */
#define PATH_LOG "/dev/log"

#endif  /* end of !__ASSEMBLER__ */
	
#endif //_KERNEL_SUBST64_H

