/* 
 * mutex.h
 *
 * interface for simple mutex operations 
 *
 */
 /*
 *
 * This file has been derived from GNU libc. Please see COPYING.LIBC
 * for more information
 *
 */
 /*
 * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of GNU Lesser General Public
 * License as published by the Free Software Foundation
 * version 2.1 of the License.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Lesser General Public License for more details.
 *
 * You should have recieved a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 * or view it at http://www.gnu.org/licenses/lgpl.html
 *
 * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
*/

#ifndef _MUTEX_H
#define _MUTEX_H
#define __SIZEOF_MUTEX_T 16

typedef struct mutex_opaque_t {
	unsigned long mopq[__SIZEOF_MUTEX_T / sizeof(unsigned long)];
} mutex_opaque;
typedef mutex_opaque * mutex_handle;


/* mutex implementation */
extern int mutex_lock (mutex_handle);
extern int mutex_unlock (mutex_handle);
extern int mutex_init (mutex_handle mutex);
extern int mutex_trylock (mutex_handle);
extern unsigned long get_mutex_owner (mutex_handle);
extern mutex_handle mutex_create (void);
extern void mutex_destroy (mutex_handle mh);

#endif // _MUTEX_H
