/* 
 * stdio.h
 * declatration for fprintf
 */
 /*
 *
 * This file has been derived from GNU libc. Please see COPYING.LIBC
 * for more information
 *
 */
 /*
 * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of GNU Lesser General Public
 * License as published by the Free Software Foundation
 * version 2.1 of the License.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Lesser General Public License for more details.
 *
 * You should have recieved a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 * or view it at http://www.gnu.org/licenses/lgpl.html
 *
 * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
*/



#ifndef _STDIO_H
#define _STDIO_H

#include "../ia32x_utils.h"
#include "../include/strings.h"
#include "../include/ia64_syscalls.h"

#define stdout STDOUT_FILENO
#define stderr STDERR_FILENO

#define fprintf(fd,format,args...)						\
do {										\
        char fdprintf_buffer[4096];						\
        long __attribute__((unused)) _r;					\
        sprintf (fdprintf_buffer, format, ## args);				\
        _r = SYSCALL (write, (fd, fdprintf_buffer, strlen(fdprintf_buffer)));	\
} while (0)
#define printf(format,args...) fprintf (stdout, format, ## args)

#if DEBUG
#define DBPRINT(sw,format,args...) do {						\
	if (sw) {								\
		fprintf (g_log_file, "(%d) %s:%s - " format, 			\
			 sys_gettid(), __FILE__, __FUNCTION__, ## args);	\
	}									\
} while (0)
#else
#define DBPRINT(sw,format,args...)
#endif

#define IS_SYS_ERROR(result)  (((long)(result) < 0) && ((long)(result) > -4096))
#define sys_err_chk(result,msg)							\
{										\
	if (IS_SYS_ERROR (result)) {						\
		DBPRINT (1, "failure: %s:[%ld]\n", msg, result);		\
		abort ();							\
	}									\
}

#endif // _STDIO_H


