/* 
 * strings.h
 * prototypes of string functions
 */
 /*
 *
 * This file has been derived from GNU libc. Please see COPYING.LIBC
 * for more information
 *
 */
 /*
 * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of GNU Lesser General Public
 * License as published by the Free Software Foundation
 * version 2.1 of the License.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Lesser General Public License for more details.
 *
 * You should have recieved a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 * or view it at http://www.gnu.org/licenses/lgpl.html
 *
 * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
*/

#ifndef _STRINGS_H
#define _STRINGS_H

extern void *memcpy(void *dest, const void *src, unsigned long n);
extern void *memset(void *s, int c, unsigned long n);
extern void *memmove(void *dest, const void *src, unsigned long n);
extern int memcmp(const void *s1, const void *s2, unsigned long n);

extern char *strcat(char *dest, const char *src);
extern char *strncat(char *dest, const char *src, unsigned long len);
extern int strcmp(const char *s1, const char *s2);
extern char *strcpy(char *dest, const char *src);
extern unsigned long strlen(const char *s);
extern unsigned long strnlen (const char * string, unsigned long maxlen);
extern char * strchr (const char * s, int c);
extern int strncmp(const char *s1, const char *s2, unsigned long len);
extern char *strncpy(const char *dest, const char *src, unsigned long n);
extern char * strstr(const char *haystack, const char *needle);

extern int sprintf(char *str, const char *format, ...);
extern long atol(const char *nptr);


#endif // _STRINGS_H

