/*  
 * start.S
 *  
 * entry point of the application
 * 
*/
 /*
 *
 * This file has been derived from GNU libc. Please see COPYING.LIBC
 * for more information
 *
 */
 /*
 * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of GNU Lesser General Public
 * License as published by the Free Software Foundation
 * version 2.1 of the License.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Lesser General Public License for more details.
 *
 * You should have recieved a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 * or view it at http://www.gnu.org/licenses/lgpl.html
 *
 * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
*/
#include "../include/asm.h"

.global before_main
.type before_main, @function
.global sys_exit
.type sys_exit, @function

PROCEDURE_ENTRY(_start)
        alloc   r31 = ar.pfs, 0, 0, 8, 0
        movl    gp = __gp               // use the linker's gp
        add     sp = 16, sp             // remove scratch space
        ;;
        ld8     out0 = [sp]             // argc
        add     out1 = 8, sp            // argv
        add     out2 = 16, sp           // envp
        ;;
        shl     r30 = out0, 3           // envp
        ;;
        add     out2 = out2, r30        // envp
        add     sp = -16, sp            // scratch space on stack for main()
        br.call.sptk.few b0 = before_main  // call main
        ;;
        mov     out0 = r8               // use main's return value for exit
        br.call.sptk.few b0 = sys_exit  // call exit
        ;;
        mov     b6 = r0
        br.call.sptk.few b0 = b6        // kill the program
PROCEDURE_EXIT(_start)
