/*  
 * longjmp.c
 *  
 * wrapper for the longjmp implementation
 * 
 */
 /*
 *
 * This file has been derived from GNU libc. Please see COPYING.LIBC
 * for more information
 *
 */
 /*
 * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of GNU Lesser General Public
 * License as published by the Free Software Foundation
 * version 2.1 of the License.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Lesser General Public License for more details.
 *
 * You should have recieved a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 * or view it at http://www.gnu.org/licenses/lgpl.html
 *
 * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
*/

#include "../ia32x_utils.h"

extern void __longjmp(__jmp_buf buf, int val);
/* Set the signal mask to the one specified in ENV, and jump
   to the position specified in ENV, causing the setjmp
   call there to return VAL, or 1 if VAL is 0.  */
void
longjmp (jmp_buf env, int val)
{

	if (env[0].__mask_was_saved) {
		long r;
		/* Restore the saved signal mask.  */
		r = SYSCALL (rt_sigprocmask, (SIG_SETMASK,
					&env[0].__saved_mask,
				  	(void *) 0ul,
					sizeof (k_sigset_t)));
		sys_err_chk (r, "sigprocmask failed");
	}

	/* Call the machine-dependent function to restore machine state.  */
	__longjmp (env[0].__jmpbuf, val ?: 1);
}
