/*  
 * sigjmp.c
 *  
 * implementation of sigjmp function, needed by sigsetjmp
 * 
 */
 /*
 *
 * This file has been derived from GNU libc. Please see COPYING.LIBC
 * for more information
 *
 */
 /*
 * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of GNU Lesser General Public
 * License as published by the Free Software Foundation
 * version 2.1 of the License.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Lesser General Public License for more details.
 *
 * You should have recieved a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 * or view it at http://www.gnu.org/licenses/lgpl.html
 *
 * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
*/

#include "../include/setjmp.h"
#include "../include/stdio.h"

/* This function is called by the `sigsetjmp' macro
   before doing a `__setjmp' on ENV[0].__jmpbuf.
   Always return zero.  */

extern int __sigjmp_save (jmp_buf env, int savemask);
int __sigjmp_save (jmp_buf env, int savemask)
{
	env[0].__mask_was_saved = savemask;

	if (savemask) {
		long r;
		r = SYSCALL (rt_sigprocmask, (0, 0ul, &env[0].__saved_mask, sizeof (k_sigset_t)));
		if (IS_SYS_ERROR (r)) {
			env[0].__mask_was_saved = 0;
		}
	}

	return 0;
}
