/* 
 * atol.c
 *
 * implement the atol function
 *
 */
 /*
 *
 * This file has been derived from GNU libc. Please see COPYING.LIBC
 * for more information
 *
 */
 /*
 * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of GNU Lesser General Public
 * License as published by the Free Software Foundation
 * version 2.1 of the License.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Lesser General Public License for more details.
 *
 * You should have recieved a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 * or view it at http://www.gnu.org/licenses/lgpl.html
 *
 * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
*/

#include "../ia32x_utils.h"

/* converts a string representation of a decimal number to long.
 * input - nptr: a null terminated string
 * output - the number represented by the string
 * notes -  no checks are made to make sure the input is valid
 */
long atol(const char *nptr)
{
	const char * p = nptr;
	long n = 0;
	int is_negative;

	if (*p == '-') {
		is_negative = 1;
		p ++;
	} else {
		is_negative = 0;
	}

	while ((*p <= '9') && (*p >= '0')) {
		n = n * 10 + *p - '0';
		p ++;
	}

	if (is_negative) {
		n = -n;
	}

	return n;
}

