/*  
 * strnlen.S
 *  
 * optimized implementation of the strnlen function
 * 
 */
 /*
 *
 * This file has been derived from GNU libc. Please see COPYING.LIBC
 * for more information
 *
 */
 /*
 * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of GNU Lesser General Public
 * License as published by the Free Software Foundation
 * version 2.1 of the License.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Lesser General Public License for more details.
 *
 * You should have recieved a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 * or view it at http://www.gnu.org/licenses/lgpl.html
 *
 * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
*/


#include "../ia32x_utils.h"
#include "../include/strings.h"

/* Find the length of STRING, but scan at most MAXLEN characters.
   If no '\0' terminator is found in that many characters, return MAXLEN.  */

static void * memchr (const void *__s, int __c, unsigned long __n);
unsigned long strnlen (const char * string, unsigned long maxlen)
{
	const char *end;
       	end = memchr (string, '\0', maxlen);
	return end ? (unsigned long) (end - string) : maxlen;
}

static void * memchr (const void * str, int chr, unsigned long count)
{
	unsigned long j = 0;
	const char * p = str;
	int found = 0;


	while (! found && j < count) { 
		if (*p == chr) {
			found = 1;
		} else {
			p ++;
			j ++;
		}
	}
	return (char*)(found ? p : NULL);
}
