/*  
 * syscalls.S
 *  
 * implementation of sys_* functions
 * 
 */
 /*
 *
 * This file has been derived from GNU libc. Please see COPYING.LIBC
 * for more information
 *
 */
 /*
 * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of GNU Lesser General Public
 * License as published by the Free Software Foundation
 * version 2.1 of the License.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Lesser General Public License for more details.
 *
 * You should have recieved a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 * or view it at http://www.gnu.org/licenses/lgpl.html
 *
 * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
*/

#include "../ia32x_utils.h"

#define SYS_lcs_getpagesize 1171
#define SYS_newuname SYS_uname

.global g_at_sysinfo

#define FSYSCALL(name)      		\
.psr abi64                 		;\
.psr lsb                   		;\
.lsb                       		;\
.text                      		;\
.global sys_##name         		;\
.proc sys_##name           		;\
sys_##name:                 		\
					\
.prologue				;\
.save ar.pfs, r11			;\
mov r11 = ar.pfs			;\
.body					;\
					;\
mov r15 = SYS_##name			;\
addl r14=@ltoff(g_at_sysinfo), r1	;\
;;					;\
ld8 r16 = [r14]				;\
;;					;\
ld8 r2 = [r16]				;\
;;					;\
cmp.eq	p6,p7=r2,r0			;\
mov b7 = r2				;\
;;					;\
(p6)break __BREAK_SYSCALL		;\
(p7)br.call.sptk.many b6 = b7		;\
;;					;\
					;\
cmp.eq	p6,p7=r10,r0			;\
;;					;\
(p7)sub	r8=r0, r8			;\
					;\
mov ar.pfs = r11			;\
br.ret.sptk.many rp			;\
;;					;\
.endp sys_##name






FSYSCALL(exit)
FSYSCALL(read)
FSYSCALL(write)
FSYSCALL(open)
FSYSCALL(close)
FSYSCALL(creat)
FSYSCALL(link)
FSYSCALL(unlink)
FSYSCALL(execve)
FSYSCALL(chdir)
FSYSCALL(fchdir)
FSYSCALL(utimes)
FSYSCALL(mknod)
FSYSCALL(chmod)
FSYSCALL(chown)
FSYSCALL(lseek)
FSYSCALL(getpid)
FSYSCALL(getppid)
FSYSCALL(mount)
FSYSCALL(umount)
FSYSCALL(setuid)
FSYSCALL(getuid)
FSYSCALL(geteuid)
FSYSCALL(ptrace)
FSYSCALL(access)
FSYSCALL(sync)
FSYSCALL(fsync)
FSYSCALL(fdatasync)
FSYSCALL(kill)
FSYSCALL(rename)
FSYSCALL(mkdir)
FSYSCALL(rmdir)
FSYSCALL(dup)
FSYSCALL(pipe)
FSYSCALL(times)
FSYSCALL(brk)
FSYSCALL(setgid)
FSYSCALL(getgid)
FSYSCALL(getegid)
FSYSCALL(acct)
FSYSCALL(ioctl)
FSYSCALL(fcntl)
FSYSCALL(umask)
FSYSCALL(chroot)
FSYSCALL(ustat)
FSYSCALL(dup2)
FSYSCALL(setreuid)
FSYSCALL(setregid)
FSYSCALL(getresuid)
FSYSCALL(setresuid)
FSYSCALL(getresgid)
FSYSCALL(setresgid)
FSYSCALL(getgroups)
FSYSCALL(setgroups)
FSYSCALL(getpgid)
FSYSCALL(setpgid)
FSYSCALL(setsid)
FSYSCALL(getsid)
FSYSCALL(sethostname)
FSYSCALL(setrlimit)
FSYSCALL(getrlimit)
FSYSCALL(getrusage)
FSYSCALL(gettimeofday)
FSYSCALL(settimeofday)
FSYSCALL(select)
FSYSCALL(poll)
FSYSCALL(symlink)
FSYSCALL(readlink)
FSYSCALL(uselib)
FSYSCALL(swapon)
FSYSCALL(swapoff)
FSYSCALL(reboot)
FSYSCALL(truncate)
FSYSCALL(ftruncate)
FSYSCALL(fchmod)
FSYSCALL(fchown)
FSYSCALL(getpriority)
FSYSCALL(setpriority)
FSYSCALL(statfs)
FSYSCALL(fstatfs)
FSYSCALL(gettid)
FSYSCALL(semget)
FSYSCALL(semop)
FSYSCALL(semctl)
FSYSCALL(msgget)
FSYSCALL(msgsnd)
FSYSCALL(msgrcv)
FSYSCALL(msgctl)
FSYSCALL(shmget)
FSYSCALL(shmat)
FSYSCALL(shmdt)
FSYSCALL(shmctl)
FSYSCALL(syslog)
FSYSCALL(setitimer)
FSYSCALL(getitimer)
/*FSYSCALL(old_stat)*/
/*FSYSCALL(old_lstat)*/
/*FSYSCALL(old_fstat)*/
FSYSCALL(vhangup)
FSYSCALL(lchown)
/*FSYSCALL(vm86)*/
FSYSCALL(wait4)
FSYSCALL(sysinfo)
FSYSCALL(clone)
FSYSCALL(setdomainname)
FSYSCALL(newuname)
FSYSCALL(adjtimex)
FSYSCALL(create_module)
FSYSCALL(init_module)
FSYSCALL(delete_module)
FSYSCALL(get_kernel_syms)
FSYSCALL(query_module)
FSYSCALL(quotactl)
FSYSCALL(bdflush)
FSYSCALL(sysfs)
FSYSCALL(personality)
FSYSCALL(afs_syscall)
FSYSCALL(setfsuid)
FSYSCALL(setfsgid)
FSYSCALL(getdents)
FSYSCALL(flock)
FSYSCALL(readv)
FSYSCALL(writev)
FSYSCALL(pread)
FSYSCALL(pwrite)
FSYSCALL(_sysctl)
FSYSCALL(mmap)
FSYSCALL(munmap)
FSYSCALL(mlock)
FSYSCALL(mlockall)
FSYSCALL(mprotect)
FSYSCALL(mremap)
FSYSCALL(msync)
FSYSCALL(munlock)
FSYSCALL(munlockall)
FSYSCALL(sched_getparam)
FSYSCALL(sched_setparam)
FSYSCALL(sched_getscheduler)
FSYSCALL(sched_setscheduler)
FSYSCALL(sched_yield)
FSYSCALL(sched_get_priority_max)
FSYSCALL(sched_get_priority_min)
FSYSCALL(sched_rr_get_interval)
FSYSCALL(nanosleep)
FSYSCALL(nfsservctl)
FSYSCALL(prctl)
FSYSCALL(mmap2)
FSYSCALL(pciconfig_read)
FSYSCALL(pciconfig_write)
FSYSCALL(perfmonctl)
FSYSCALL(sigaltstack)
FSYSCALL(rt_sigaction)
FSYSCALL(rt_sigpending)
FSYSCALL(rt_sigprocmask)
FSYSCALL(rt_sigqueueinfo)
FSYSCALL(rt_sigreturn)
FSYSCALL(rt_sigsuspend)
FSYSCALL(rt_sigtimedwait)
FSYSCALL(getcwd)
FSYSCALL(capget)
FSYSCALL(capset)
FSYSCALL(sendfile)
FSYSCALL(getpmsg)
FSYSCALL(putpmsg)
FSYSCALL(socket)
FSYSCALL(bind)
FSYSCALL(connect)
FSYSCALL(listen)
FSYSCALL(accept)
FSYSCALL(getsockname)
FSYSCALL(getpeername)
FSYSCALL(socketpair)
FSYSCALL(send)
FSYSCALL(sendto)
FSYSCALL(recv)
FSYSCALL(recvfrom)
FSYSCALL(shutdown)
FSYSCALL(setsockopt)
FSYSCALL(getsockopt)
FSYSCALL(sendmsg)
FSYSCALL(recvmsg)
FSYSCALL(pivot_root)
FSYSCALL(mincore)
FSYSCALL(madvise)
FSYSCALL(stat)
FSYSCALL(lstat)
FSYSCALL(fstat)
FSYSCALL(clone2)
FSYSCALL(getdents64)
FSYSCALL(getunwind)
FSYSCALL(readahead)
FSYSCALL(setxattr)
FSYSCALL(lsetxattr)
FSYSCALL(fsetxattr)
FSYSCALL(getxattr)
FSYSCALL(lgetxattr)
FSYSCALL(fgetxattr)
FSYSCALL(listxattr)
FSYSCALL(llistxattr)
FSYSCALL(flistxattr)
FSYSCALL(removexattr)
FSYSCALL(lremovexattr)
FSYSCALL(fremovexattr)
FSYSCALL(tkill)
FSYSCALL(futex)
FSYSCALL(sched_setaffinity)
FSYSCALL(sched_getaffinity)
FSYSCALL(set_tid_address)
FSYSCALL(tgkill)
FSYSCALL(exit_group)
FSYSCALL(lookup_dcookie)
FSYSCALL(io_setup)
FSYSCALL(io_destroy)
FSYSCALL(io_getevents)
FSYSCALL(io_submit)
FSYSCALL(io_cancel)
FSYSCALL(epoll_create)
FSYSCALL(epoll_ctl)
FSYSCALL(epoll_wait)
FSYSCALL(restart_syscall)
FSYSCALL(semtimedop)

FSYSCALL(lcs_getpagesize)

FSYSCALL(timer_create)
FSYSCALL(timer_settime)
FSYSCALL(timer_gettime)
FSYSCALL(clock_settime)
FSYSCALL(clock_gettime)
FSYSCALL(clock_getres)
FSYSCALL(clock_nanosleep)
FSYSCALL(fstatfs64)
FSYSCALL(fadvise64)
